//Internally generated header file.
//Do not mess with it

switch(grid->flags & RASTER_GLOBAL_MASK) {
case 0:
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	break;
case 1:
	#define STOCHASTIC_MOVING
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	break;
case 2:
	#define STOCHASTIC_TRANSPARENT
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	break;
case 3:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	break;
case 4:
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	break;
case 5:
	#define STOCHASTIC_MOVING
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	break;
case 6:
	#define STOCHASTIC_TRANSPARENT
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	break;
case 7:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	break;
case 8:
	#define STOCHASTIC_UNSHADED
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_UNSHADED
	break;
case 9:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	break;
case 10:
	break;
case 11:
	break;
case 12:
	#define STOCHASTIC_UNSHADED
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_UNSHADED
	break;
case 13:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	break;
case 14:
	break;
case 15:
	break;
case 16:
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 17:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 18:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 19:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 20:
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 21:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 22:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 23:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 24:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 25:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 26:
	break;
case 27:
	break;
case 28:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 29:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	break;
case 30:
	break;
case 31:
	break;
case 32:
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 33:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 34:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 35:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 36:
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 37:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 38:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 39:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 40:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 41:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 42:
	break;
case 43:
	break;
case 44:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 45:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 46:
	break;
case 47:
	break;
case 48:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 49:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 50:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 51:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 52:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 53:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 54:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 55:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 56:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 57:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 58:
	break;
case 59:
	break;
case 60:
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 61:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_UNSHADED
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_UNSHADED
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	break;
case 62:
	break;
case 63:
	break;
case 64:
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MATTE
	break;
case 65:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_MATTE
	break;
case 66:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_MATTE
	break;
case 67:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_MATTE
	break;
case 68:
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MATTE
	break;
case 69:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_MATTE
	break;
case 70:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_MATTE
	break;
case 71:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_MATTE
	break;
case 72:
	break;
case 73:
	break;
case 74:
	break;
case 75:
	break;
case 76:
	break;
case 77:
	break;
case 78:
	break;
case 79:
	break;
case 80:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 81:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 82:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 83:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 84:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 85:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 86:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 87:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_MATTE
	break;
case 88:
	break;
case 89:
	break;
case 90:
	break;
case 91:
	break;
case 92:
	break;
case 93:
	break;
case 94:
	break;
case 95:
	break;
case 96:
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 97:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 98:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 99:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 100:
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 101:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 102:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 103:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 104:
	break;
case 105:
	break;
case 106:
	break;
case 107:
	break;
case 108:
	break;
case 109:
	break;
case 110:
	break;
case 111:
	break;
case 112:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 113:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 114:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 115:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticTriangle.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 116:
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 117:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 118:
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 119:
	#define STOCHASTIC_MOVING
	#define STOCHASTIC_TRANSPARENT
	#define STOCHASTIC_FOCAL_BLUR
	#define STOCHASTIC_EXTRA_SAMPLES
	#define STOCHASTIC_MATTE
	for(numPrimitives=grid->numPrimitives,cPrimitive=grid->primitives;numPrimitives>0;numPrimitives--,cPrimitive++) {
		if (cPrimitive->xbound[1] < left)	continue;
		if (cPrimitive->ybound[1] < top)		continue;
		if (cPrimitive->xbound[0] >= right)	continue;
		if (cPrimitive->ybound[0] >= bottom)	continue;
		#include "stochasticPoint.h"
	}
	#undef STOCHASTIC_MOVING
	#undef STOCHASTIC_TRANSPARENT
	#undef STOCHASTIC_FOCAL_BLUR
	#undef STOCHASTIC_EXTRA_SAMPLES
	#undef STOCHASTIC_MATTE
	break;
case 120:
	break;
case 121:
	break;
case 122:
	break;
case 123:
	break;
case 124:
	break;
case 125:
	break;
case 126:
	break;
case 127:
	break;
default:
	break;
}

