/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse slparse
#define yylex   sllex
#define yyerror slerror
#define yylval  sllval
#define yychar  slchar
#define yydebug sldebug
#define yynerrs slnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SL_SURFACE = 258,
     SL_DISPLACEMENT = 259,
     SL_LIGHT = 260,
     SL_VOLUME = 261,
     SL_TRANSFORMATION = 262,
     SL_IMAGER = 263,
     SL_FOR = 264,
     SL_WHILE = 265,
     SL_IF = 266,
     SL_GATHER = 267,
     SL_ELSE = 268,
     SL_BREAK = 269,
     SL_CONTINUE = 270,
     SL_ILLUMINANCE = 271,
     SL_ILLUMINATE = 272,
     SL_SOLAR = 273,
     SL_RETURN = 274,
     SL_VOID = 275,
     SL_FCN_PI = 276,
     SL_IDENTIFIER_VALUE = 277,
     SL_FLOAT_VALUE = 278,
     SL_COMMA = 279,
     SL_SEMI_COLON = 280,
     SL_OPEN_PARANTHESIS = 281,
     SL_CLOSE_PARANTHESIS = 282,
     SL_OPEN_CRL_PARANTHESIS = 283,
     SL_CLOSE_CRL_PARANTHESIS = 284,
     SL_OPEN_SQR_PARANTHESIS = 285,
     SL_CLOSE_SQR_PARANTHESIS = 286,
     SL_TEXTURE = 287,
     SL_SHADOW = 288,
     SL_ENVIRONMENT = 289,
     SL_BUMP = 290,
     SL_TEXT_VALUE = 291,
     SL_COLON = 292,
     SL_QUESTION = 293,
     SL_STRING = 294,
     SL_MATRIX = 295,
     SL_NORMAL = 296,
     SL_VECTOR = 297,
     SL_POINT = 298,
     SL_COLOR = 299,
     SL_FLOAT = 300,
     SL_COMP_DIFFERENT = 301,
     SL_COMP_EQUAL = 302,
     SL_COMP_LESS_EQUAL = 303,
     SL_COMP_LESS = 304,
     SL_COMP_GREATER_EQUAL = 305,
     SL_COMP_GREATER = 306,
     SL_EQUAL = 307,
     SL_DECREMENT_BY = 308,
     SL_INCREMENT_BY = 309,
     SL_DECREMENT = 310,
     SL_INCREMENT = 311,
     SL_DIVIDE_BY = 312,
     SL_MULTIPLY_BY = 313,
     SL_MINUS = 314,
     SL_PLUS = 315,
     SL_CROSS = 316,
     SL_MULTIPLY = 317,
     SL_DIVIDE = 318,
     SL_DOT = 319,
     SL_OR = 320,
     SL_AND = 321,
     SL_NOT = 322,
     SL_OUTPUT = 323,
     SL_EXTERN = 324,
     SL_UNIFORM = 325,
     SL_VARIABLE = 326,
     SL_VERTEX = 327
   };
#endif
#define SL_SURFACE 258
#define SL_DISPLACEMENT 259
#define SL_LIGHT 260
#define SL_VOLUME 261
#define SL_TRANSFORMATION 262
#define SL_IMAGER 263
#define SL_FOR 264
#define SL_WHILE 265
#define SL_IF 266
#define SL_GATHER 267
#define SL_ELSE 268
#define SL_BREAK 269
#define SL_CONTINUE 270
#define SL_ILLUMINANCE 271
#define SL_ILLUMINATE 272
#define SL_SOLAR 273
#define SL_RETURN 274
#define SL_VOID 275
#define SL_FCN_PI 276
#define SL_IDENTIFIER_VALUE 277
#define SL_FLOAT_VALUE 278
#define SL_COMMA 279
#define SL_SEMI_COLON 280
#define SL_OPEN_PARANTHESIS 281
#define SL_CLOSE_PARANTHESIS 282
#define SL_OPEN_CRL_PARANTHESIS 283
#define SL_CLOSE_CRL_PARANTHESIS 284
#define SL_OPEN_SQR_PARANTHESIS 285
#define SL_CLOSE_SQR_PARANTHESIS 286
#define SL_TEXTURE 287
#define SL_SHADOW 288
#define SL_ENVIRONMENT 289
#define SL_BUMP 290
#define SL_TEXT_VALUE 291
#define SL_COLON 292
#define SL_QUESTION 293
#define SL_STRING 294
#define SL_MATRIX 295
#define SL_NORMAL 296
#define SL_VECTOR 297
#define SL_POINT 298
#define SL_COLOR 299
#define SL_FLOAT 300
#define SL_COMP_DIFFERENT 301
#define SL_COMP_EQUAL 302
#define SL_COMP_LESS_EQUAL 303
#define SL_COMP_LESS 304
#define SL_COMP_GREATER_EQUAL 305
#define SL_COMP_GREATER 306
#define SL_EQUAL 307
#define SL_DECREMENT_BY 308
#define SL_INCREMENT_BY 309
#define SL_DECREMENT 310
#define SL_INCREMENT 311
#define SL_DIVIDE_BY 312
#define SL_MULTIPLY_BY 313
#define SL_MINUS 314
#define SL_PLUS 315
#define SL_CROSS 316
#define SL_MULTIPLY 317
#define SL_DIVIDE 318
#define SL_DOT 319
#define SL_OR 320
#define SL_AND 321
#define SL_NOT 322
#define SL_OUTPUT 323
#define SL_EXTERN 324
#define SL_UNIFORM 325
#define SL_VARIABLE 326
#define SL_VERTEX 327




/* Copy the first part of user declarations.  */
#line 61 "sl.y"

//////////////////////////////////////////////////////////////////////////
// Misc C definitions
//////////////////////////////////////////////////////////////////////////
#undef alloca
#include	"common/global.h"
#include	"common/os.h"
#include	"opcodes.h"
#include	"sdr.h"
#include	<stdlib.h>

	void				yyerror(char *);				// Forward definition for stupid yacc
	int					yylex(void );					// Forward definition for stupid yacc
														
//////////////////////////////////////////////////////////////////////////
// Here's the only global CVariable
//////////////////////////////////////////////////////////////////////////
	CScriptContext		*sdr;

//////////////////////////////////////////////////////////////////////////




/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 84 "sl.y"
typedef union YYSTYPE {
  char					*string;
  CExpression			*code;
  CExpression			*expression;
  float					real;
  int					integer;
  CArray<CExpression *>	*array;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 262 "sl.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 274 "sl.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2099

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  105
/* YYNRULES -- Number of rules. */
#define YYNRULES  247
/* YYNRULES -- Number of states. */
#define YYNSTATES  485

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   327

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    14,    16,
      17,    19,    20,    22,    24,    26,    28,    30,    32,    34,
      39,    42,    44,    48,    52,    57,    59,    60,    64,    67,
      69,    70,    74,    75,    80,    82,    83,    90,    91,    99,
     103,   108,   109,   110,   119,   121,   123,   125,   127,   129,
     131,   133,   134,   138,   141,   143,   144,   148,   151,   154,
     155,   160,   161,   165,   166,   174,   175,   182,   183,   185,
     189,   190,   195,   198,   201,   204,   205,   209,   210,   215,
     216,   223,   224,   232,   235,   237,   239,   241,   243,   246,
     247,   249,   251,   253,   255,   258,   261,   263,   265,   267,
     269,   271,   273,   275,   277,   279,   282,   284,   286,   288,
     290,   292,   294,   296,   298,   302,   305,   309,   312,   316,
     319,   324,   327,   330,   331,   336,   337,   345,   346,   351,
     352,   357,   360,   363,   364,   369,   370,   375,   376,   384,
     385,   393,   399,   405,   406,   414,   415,   423,   425,   435,
     445,   447,   448,   452,   454,   456,   457,   459,   460,   464,
     466,   470,   472,   480,   486,   494,   498,   500,   501,   507,
     512,   515,   520,   522,   528,   536,   546,   558,   564,   574,
     580,   590,   596,   606,   611,   619,   624,   632,   634,   638,
     642,   646,   650,   651,   656,   660,   663,   666,   672,   676,
     680,   682,   684,   686,   688,   690,   692,   694,   699,   701,
     703,   711,   745,   749,   752,   756,   760,   764,   768,   772,
     776,   780,   784,   788,   792,   796,   800,   803,   805,   807,
     810,   813,   816,   820,   822,   824,   828,   829,   837,   843,
     845,   847,   849,   851,   853,   854,   855,   860
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
      74,     0,    -1,    -1,    75,    81,    -1,    70,    -1,    71,
      -1,    72,    -1,    -1,    69,    -1,    -1,    68,    -1,    -1,
      45,    -1,    44,    -1,    42,    -1,    41,    -1,    43,    -1,
      40,    -1,    39,    -1,    77,    78,    76,    79,    -1,    83,
      81,    -1,    92,    -1,    80,    22,    26,    -1,    20,    22,
      26,    -1,    82,    84,    27,   107,    -1,    85,    -1,    -1,
      86,    25,    85,    -1,    86,    25,    -1,    86,    -1,    -1,
      80,    87,    88,    -1,    -1,    22,    89,    24,    88,    -1,
      22,    -1,    -1,    22,    30,    31,    90,    24,    88,    -1,
      -1,    22,    30,    23,    31,    91,    24,    88,    -1,    22,
      30,    31,    -1,    22,    30,    23,    31,    -1,    -1,    -1,
      95,    22,    26,    93,    96,    27,    94,   107,    -1,     3,
      -1,     4,    -1,     5,    -1,     6,    -1,     7,    -1,     8,
      -1,    97,    -1,    -1,    98,    25,    97,    -1,    98,    25,
      -1,    98,    -1,    -1,    80,    99,   106,    -1,    52,   161,
      -1,    52,   163,    -1,    -1,    22,    24,   102,   101,    -1,
      -1,    22,   103,   100,    -1,    -1,    22,    30,    23,    31,
      24,   104,   101,    -1,    -1,    22,    30,    23,    31,   105,
     100,    -1,    -1,   101,    -1,   101,    24,   106,    -1,    -1,
      28,   108,   118,    29,    -1,    80,   111,    -1,    52,   161,
      -1,    52,   163,    -1,    -1,    22,   112,   116,    -1,    -1,
      22,   113,   110,   116,    -1,    -1,    22,    30,    23,    31,
     114,   116,    -1,    -1,    22,    30,    23,    31,   115,   110,
     116,    -1,    24,   111,    -1,    25,    -1,   120,    -1,   119,
      -1,     1,    -1,   118,   117,    -1,    -1,   140,    -1,   125,
      -1,   147,    -1,   152,    -1,   127,    25,    -1,   130,    25,
      -1,   121,    -1,   122,    -1,   123,    -1,   155,    -1,   157,
      -1,   159,    -1,   107,    -1,   109,    -1,    83,    -1,   168,
      25,    -1,    25,    -1,   148,    -1,   153,    -1,   126,    -1,
     141,    -1,   156,    -1,   158,    -1,   160,    -1,    14,    23,
      25,    -1,    14,    25,    -1,    15,    23,    25,    -1,    15,
      25,    -1,    19,   161,    25,    -1,    19,    25,    -1,    10,
      26,   167,    27,    -1,   124,   119,    -1,   124,   120,    -1,
      -1,    22,    52,   128,   161,    -1,    -1,    22,    30,   161,
      31,    52,   129,   161,    -1,    -1,    22,    54,   131,   161,
      -1,    -1,    22,    53,   132,   161,    -1,    22,    56,    -1,
      22,    55,    -1,    -1,    22,    58,   133,   161,    -1,    -1,
      22,    57,   134,   161,    -1,    -1,    22,    30,   161,    31,
      54,   135,   161,    -1,    -1,    22,    30,   161,    31,    53,
     136,   161,    -1,    22,    30,   161,    31,    56,    -1,    22,
      30,   161,    31,    55,    -1,    -1,    22,    30,   161,    31,
      58,   137,   161,    -1,    -1,    22,    30,   161,    31,    57,
     138,   161,    -1,     9,    -1,   139,    26,   142,    25,   144,
      25,   145,    27,   119,    -1,   139,    26,   142,    25,   144,
      25,   145,    27,   120,    -1,   143,    -1,    -1,   127,    24,
     143,    -1,   127,    -1,   167,    -1,    -1,   146,    -1,    -1,
     127,    24,   146,    -1,   127,    -1,   130,    24,   146,    -1,
     130,    -1,    11,    26,   167,    27,   119,    13,   119,    -1,
      11,    26,   167,    27,   117,    -1,    11,    26,   167,    27,
     119,    13,   120,    -1,   149,    24,   161,    -1,   161,    -1,
      -1,    12,    26,   151,   149,    27,    -1,   150,   119,    13,
     119,    -1,   150,   117,    -1,   150,   119,    13,   120,    -1,
      16,    -1,   154,    26,   161,    27,   119,    -1,   154,    26,
     161,    24,   161,    27,   119,    -1,   154,    26,   161,    24,
     161,    24,   161,    27,   119,    -1,   154,    26,   161,    24,
     161,    24,   161,    24,   161,    27,   119,    -1,   154,    26,
     161,    27,   120,    -1,   154,    26,   161,    24,   161,    24,
     161,    27,   120,    -1,    17,    26,   161,    27,   119,    -1,
      17,    26,   161,    24,   161,    24,   161,    27,   119,    -1,
      17,    26,   161,    27,   120,    -1,    17,    26,   161,    24,
     161,    24,   161,    27,   120,    -1,    18,    26,    27,   119,
      -1,    18,    26,   161,    24,   161,    27,   119,    -1,    18,
      26,    27,   120,    -1,    18,    26,   161,    24,   161,    27,
     120,    -1,   165,    -1,   161,    60,   161,    -1,   161,    59,
     161,    -1,   161,    62,   161,    -1,   161,    63,   161,    -1,
      -1,   161,    64,   162,   161,    -1,   161,    61,   161,    -1,
      60,   161,    -1,    59,   161,    -1,   167,    38,   161,    37,
     161,    -1,    28,   164,    29,    -1,   161,    24,   164,    -1,
     161,    -1,    21,    -1,   127,    -1,   130,    -1,   166,    -1,
     168,    -1,    22,    -1,    22,    30,   161,    31,    -1,    23,
      -1,    36,    -1,    26,   161,    24,   161,    24,   161,    27,
      -1,    26,   161,    24,   161,    24,   161,    24,   161,    24,
     161,    24,   161,    24,   161,    24,   161,    24,   161,    24,
     161,    24,   161,    24,   161,    24,   161,    24,   161,    24,
     161,    24,   161,    27,    -1,    26,   161,    27,    -1,    80,
     161,    -1,    80,    36,   161,    -1,    26,   167,    27,    -1,
     167,    66,   167,    -1,   167,    65,   167,    -1,   161,    51,
     161,    -1,   161,    49,   161,    -1,   161,    50,   161,    -1,
     161,    48,   161,    -1,   161,    47,   161,    -1,   161,    46,
     161,    -1,   167,    47,   167,    -1,   167,    46,   167,    -1,
      67,   167,    -1,   173,    -1,   170,    -1,    22,    26,    -1,
       3,    26,    -1,     4,    26,    -1,   169,   175,    27,    -1,
      36,    -1,    22,    -1,    30,   161,    31,    -1,    -1,   174,
      26,   171,   172,    24,   175,    27,    -1,   174,    26,   171,
     172,    27,    -1,    32,    -1,    33,    -1,    34,    -1,    35,
      -1,   176,    -1,    -1,    -1,   161,    24,   177,   176,    -1,
     161,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   247,   247,   247,   255,   260,   265,   270,   277,   282,
     288,   293,   299,   304,   309,   314,   319,   324,   329,   336,
     356,   361,   376,   392,   403,   424,   429,   438,   445,   451,
     461,   460,   488,   487,   499,   511,   508,   526,   522,   542,
     553,   578,   589,   575,   610,   615,   620,   625,   630,   635,
     644,   649,   657,   664,   670,   680,   679,   709,   723,   743,
     741,   754,   753,   769,   764,   788,   784,   805,   812,   817,
     830,   829,   849,   870,   876,   885,   884,   898,   897,   916,
     912,   937,   933,   959,   965,   975,   982,   988,   998,  1004,
    1013,  1018,  1023,  1028,  1033,  1038,  1043,  1048,  1053,  1058,
    1063,  1068,  1073,  1078,  1083,  1088,  1093,  1102,  1107,  1112,
    1117,  1122,  1127,  1132,  1141,  1168,  1197,  1224,  1251,  1280,
    1304,  1317,  1327,  1342,  1340,  1365,  1360,  1389,  1387,  1409,
    1407,  1427,  1438,  1451,  1449,  1471,  1469,  1494,  1489,  1517,
    1512,  1535,  1549,  1568,  1563,  1591,  1586,  1613,  1619,  1636,
    1655,  1660,  1668,  1675,  1684,  1689,  1697,  1702,  1710,  1717,
    1722,  1729,  1738,  1753,  1762,  1779,  1786,  1796,  1794,  1810,
    1823,  1830,  1843,  1851,  1862,  1875,  1890,  1909,  1920,  1939,
    1950,  1967,  1978,  1997,  2007,  2022,  2032,  2049,  2054,  2061,
    2068,  2101,  2110,  2108,  2119,  2126,  2132,  2138,  2156,  2165,
    2173,  2181,  2186,  2191,  2196,  2201,  2206,  2219,  2234,  2239,
    2244,  2255,  2311,  2321,  2329,  2340,  2347,  2354,  2361,  2369,
    2377,  2385,  2393,  2401,  2409,  2417,  2425,  2436,  2476,  2485,
    2500,  2515,  2532,  2611,  2616,  2627,  2634,  2645,  2669,  2693,
    2706,  2719,  2732,  2749,  2753,  2760,  2758,  2767
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SL_SURFACE", "SL_DISPLACEMENT",
  "SL_LIGHT", "SL_VOLUME", "SL_TRANSFORMATION", "SL_IMAGER", "SL_FOR",
  "SL_WHILE", "SL_IF", "SL_GATHER", "SL_ELSE", "SL_BREAK", "SL_CONTINUE",
  "SL_ILLUMINANCE", "SL_ILLUMINATE", "SL_SOLAR", "SL_RETURN", "SL_VOID",
  "SL_FCN_PI", "SL_IDENTIFIER_VALUE", "SL_FLOAT_VALUE", "SL_COMMA",
  "SL_SEMI_COLON", "SL_OPEN_PARANTHESIS", "SL_CLOSE_PARANTHESIS",
  "SL_OPEN_CRL_PARANTHESIS", "SL_CLOSE_CRL_PARANTHESIS",
  "SL_OPEN_SQR_PARANTHESIS", "SL_CLOSE_SQR_PARANTHESIS", "SL_TEXTURE",
  "SL_SHADOW", "SL_ENVIRONMENT", "SL_BUMP", "SL_TEXT_VALUE", "SL_COLON",
  "SL_QUESTION", "SL_STRING", "SL_MATRIX", "SL_NORMAL", "SL_VECTOR",
  "SL_POINT", "SL_COLOR", "SL_FLOAT", "SL_COMP_DIFFERENT", "SL_COMP_EQUAL",
  "SL_COMP_LESS_EQUAL", "SL_COMP_LESS", "SL_COMP_GREATER_EQUAL",
  "SL_COMP_GREATER", "SL_EQUAL", "SL_DECREMENT_BY", "SL_INCREMENT_BY",
  "SL_DECREMENT", "SL_INCREMENT", "SL_DIVIDE_BY", "SL_MULTIPLY_BY",
  "SL_MINUS", "SL_PLUS", "SL_CROSS", "SL_MULTIPLY", "SL_DIVIDE", "SL_DOT",
  "SL_OR", "SL_AND", "SL_NOT", "SL_OUTPUT", "SL_EXTERN", "SL_UNIFORM",
  "SL_VARIABLE", "SL_VERTEX", "$accept", "slStart", "@1",
  "slContainerClass", "slInheritanceClass", "slOutputClass",
  "slTypeSpecifier", "slTypeDecl", "slShader", "slFunctionHeader",
  "slFunction", "slFunctionParameterList", "slFunctionParameters",
  "slFunctionParameter", "@2", "slFunctionParameterIdentifierList", "@3",
  "@4", "@5", "slMain", "@6", "@7", "slShaderType",
  "slShaderParameterList", "slShaderParameters", "slShaderParameter", "@8",
  "slShaderParameterInitializer", "slShaderParameterIdentifierToken", "@9",
  "@10", "@11", "@12", "slShaderParameterIdentifierList", "slBlock", "@13",
  "slVariableDeclerations", "slVariableInitializer",
  "slVariableIdentifierList", "@14", "@15", "@16", "@17",
  "slVariableIdentifierTail", "slStatement", "slStatements",
  "slMatchedStatement", "slUnmatchedStatement", "slBreakStatement",
  "slContinueStatement", "slReturnStatement", "slWhileStartStatement",
  "slWhileStatement", "slUnmatchedWhileStatement", "slAssignmentStatement",
  "@18", "@19", "slUpdateStatement", "@20", "@21", "@22", "@23", "@24",
  "@25", "@26", "@27", "slForStartStatement", "slForStatement",
  "slUnmatchedForStatement", "slForInitStatement", "slForInitStatements",
  "slForCheckStatement", "slForIncrementStatement",
  "slForIncrementStatements", "slMatchedIfStatement",
  "slUnmatchedIfStatement", "slGatherParameterList", "slGatherHeader",
  "@28", "slMatchedGatherStatement", "slUnmatchedGatherStatement",
  "slIlluminanceStartStatement", "slIlluminanceStatement",
  "slUnmatchedIlluminanceStatement", "slIlluminateStatement",
  "slUnmatchedIlluminateStatement", "slSolarStatement",
  "slUnmatchedSolarStatement", "slAritmeticExpression", "@29",
  "slArrayList", "slArrayItems", "slAritmeticTerminalValue",
  "slAritmeticTypeCast", "slBooleanExpression", "slFunctionCall",
  "slFunCallHeader", "slFunCall", "slTextureNameSpecifier",
  "slTextureChannelSpecifier", "slTextureCall", "slTextureName",
  "slFunctionCallParameterList", "slFunctionCallParameters", "@30", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    75,    74,    76,    76,    76,    76,    77,    77,
      78,    78,    79,    79,    79,    79,    79,    79,    79,    80,
      81,    81,    82,    82,    83,    84,    84,    85,    85,    85,
      87,    86,    89,    88,    88,    90,    88,    91,    88,    88,
      88,    93,    94,    92,    95,    95,    95,    95,    95,    95,
      96,    96,    97,    97,    97,    99,    98,   100,   100,   102,
     101,   103,   101,   104,   101,   105,   101,   101,   106,   106,
     108,   107,   109,   110,   110,   112,   111,   113,   111,   114,
     111,   115,   111,   116,   116,   117,   117,   117,   118,   118,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   120,   120,   120,
     120,   120,   120,   120,   121,   121,   122,   122,   123,   123,
     124,   125,   126,   128,   127,   129,   127,   131,   130,   132,
     130,   130,   130,   133,   130,   134,   130,   135,   130,   136,
     130,   130,   130,   137,   130,   138,   130,   139,   140,   141,
     142,   142,   143,   143,   144,   144,   145,   145,   146,   146,
     146,   146,   147,   148,   148,   149,   149,   151,   150,   152,
     153,   153,   154,   155,   155,   155,   155,   156,   156,   157,
     157,   158,   158,   159,   159,   160,   160,   161,   161,   161,
     161,   161,   162,   161,   161,   161,   161,   161,   163,   164,
     164,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   166,   166,   167,   167,   167,   167,   167,
     167,   167,   167,   167,   167,   167,   167,   168,   168,   169,
     169,   169,   170,   171,   171,   172,   172,   173,   173,   174,
     174,   174,   174,   175,   175,   177,   176,   176
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     1,     0,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     4,
       2,     1,     3,     3,     4,     1,     0,     3,     2,     1,
       0,     3,     0,     4,     1,     0,     6,     0,     7,     3,
       4,     0,     0,     8,     1,     1,     1,     1,     1,     1,
       1,     0,     3,     2,     1,     0,     3,     2,     2,     0,
       4,     0,     3,     0,     7,     0,     6,     0,     1,     3,
       0,     4,     2,     2,     2,     0,     3,     0,     4,     0,
       6,     0,     7,     2,     1,     1,     1,     1,     2,     0,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     3,     2,     3,     2,
       4,     2,     2,     0,     4,     0,     7,     0,     4,     0,
       4,     2,     2,     0,     4,     0,     4,     0,     7,     0,
       7,     5,     5,     0,     7,     0,     7,     1,     9,     9,
       1,     0,     3,     1,     1,     0,     1,     0,     3,     1,
       3,     1,     7,     5,     7,     3,     1,     0,     5,     4,
       2,     4,     1,     5,     7,     9,    11,     5,     9,     5,
       9,     5,     9,     4,     7,     4,     7,     1,     3,     3,
       3,     3,     0,     4,     3,     2,     2,     5,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     4,     1,     1,
       7,    33,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     1,     1,     3,     0,     7,     5,     1,
       1,     1,     1,     1,     0,     0,     4,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     9,     1,    44,    45,    46,    47,    48,    49,
       0,     8,    11,     0,     3,     9,     9,    21,     0,     0,
      10,     7,     0,    30,     0,    25,    29,    20,     0,    23,
       4,     5,     6,     0,    22,     0,     0,     9,    41,    18,
      17,    15,    14,    16,    13,    12,    19,    34,    31,    70,
      24,    27,     9,     0,     0,    89,    55,     0,    50,    54,
       0,    39,     0,     0,    67,    42,     9,    40,     0,    33,
      87,     0,     0,   147,     0,     0,     0,     0,     0,   172,
       0,     0,     9,     0,   106,    71,   239,   240,   241,   242,
       0,   104,   102,   103,    88,    86,    85,    96,    97,    98,
       9,    91,   109,     0,     0,     0,    90,   110,    92,   107,
       0,    93,   108,     0,    99,   111,   100,   112,   101,   113,
       0,     9,   228,   227,     0,    61,    68,    56,     0,    52,
       0,     0,   230,   231,     9,     9,   167,     0,   115,     0,
     117,     9,     9,   201,   206,   208,   119,     9,   209,     9,
       9,     9,     9,   202,   203,     0,   187,   204,     0,   205,
     229,     9,   123,   129,   127,   132,   131,   135,   133,    75,
      72,   121,   122,    94,    95,   151,   170,    86,     9,   105,
     247,     0,   243,     0,    59,     0,     0,    67,    43,     0,
      36,     0,     0,     0,     9,   114,   116,     0,     9,     0,
       9,     0,     0,   196,   195,   226,   209,   213,   118,     9,
       9,     9,     9,     9,     9,     9,     9,     9,     9,     9,
     192,     9,     9,     9,     9,     9,     0,     9,     9,     9,
       9,     9,     0,     0,     0,     0,   153,     0,   150,     9,
       0,   245,   232,   234,   233,   236,    67,     0,     9,    62,
      69,    38,   120,     0,     0,   166,     9,     9,   183,   185,
       9,     0,     9,   212,   215,   214,   223,   222,   221,   219,
     220,   218,   189,   188,   194,   190,   191,     9,     0,   225,
     224,   217,   216,     0,   124,   130,   128,   136,   134,     0,
       0,    84,    76,     9,     0,     9,     0,     9,   169,   171,
       9,     9,     9,     9,     0,    60,    65,     9,    57,    58,
     163,    86,     9,   168,     0,   179,   181,     0,   207,     0,
     193,     9,   125,   139,   137,   142,   141,   145,   143,    79,
      75,    83,    73,    74,    78,     0,   152,     0,   154,     0,
     173,   177,   246,     0,     9,   238,    63,     0,   200,     0,
       9,   165,     9,     9,     9,   197,     9,     9,     9,     9,
       9,     0,     0,     0,   157,     9,     9,   235,     0,    67,
      66,     9,   198,   162,   164,     0,   184,   186,     0,   126,
     140,   138,   146,   144,    80,     0,     0,   159,   161,     0,
     156,     0,     0,     0,     0,   174,     9,     0,     9,     0,
     237,    64,   199,     9,     9,   210,    82,     0,     0,     9,
       9,     9,     9,     9,     9,   151,     0,     9,   180,   182,
       0,   158,   160,   148,   149,     0,   175,   178,     0,     0,
       9,     0,     0,     9,     0,     9,     9,     9,     9,     9,
       9,     9,     9,     9,     0,   176,     0,     0,     0,     0,
       0,     9,     9,     9,     9,   157,     9,     0,     0,     0,
       0,     9,     9,     9,     9,     0,     9,     0,     9,     0,
       9,     0,     9,     0,     9,     0,     9,     0,     9,     0,
       9,     0,     9,     0,   211
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    33,    12,    21,    46,   152,    14,    15,
      91,    24,    25,    26,    35,    48,    54,    68,   130,    17,
      52,   128,    18,    57,    58,    59,    64,   249,   126,   246,
     186,   369,   347,   127,    92,    55,    93,   294,   170,   233,
     234,   361,   362,   292,    94,    63,   171,    96,    97,    98,
      99,   396,   101,   102,   153,   227,   356,   154,   229,   228,
     231,   230,   358,   357,   360,   359,   397,   106,   107,   237,
     238,   337,   389,   390,   108,   109,   254,   398,   194,   111,
     112,   399,   114,   115,   116,   117,   118,   119,   191,   277,
     309,   349,   156,   157,   158,   159,   121,   122,   245,   304,
     123,   124,   181,   182,   302
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -307
static const short int yypact[] =
{
    -307,    11,    49,  -307,  -307,  -307,  -307,  -307,  -307,  -307,
      20,  -307,    19,    57,  -307,   -11,    49,  -307,    67,    80,
    -307,    71,    81,  -307,    89,  -307,    92,  -307,    94,  -307,
    -307,  -307,  -307,   519,  -307,    99,   102,   -10,  -307,  -307,
    -307,  -307,  -307,  -307,  -307,  -307,  -307,    51,  -307,  -307,
    -307,  -307,    -9,     5,   107,  -307,  -307,   121,  -307,   128,
     118,   136,    99,  1045,   142,  -307,    -7,   143,   145,  -307,
    -307,   132,   140,  -307,   146,   150,   156,   129,   134,  -307,
     157,   165,   963,   230,  -307,  -307,  -307,  -307,  -307,  -307,
     170,  -307,  -307,  -307,  -307,  -307,  -307,  -307,  -307,  -307,
     587,  -307,  -307,   168,   172,   169,  -307,  -307,  -307,  -307,
    1117,  -307,  -307,   173,  -307,  -307,  -307,  -307,  -307,  -307,
     175,   152,  -307,  -307,   177,    54,   180,  -307,   102,  -307,
     181,    99,  -307,  -307,  1283,  1283,  -307,   176,  -307,   183,
    -307,  1283,  1143,  -307,   330,  -307,  -307,  1283,  -307,  1283,
    1283,  1283,  1304,  -307,  -307,  1847,  -307,  -307,    39,  -307,
    -307,  1283,  -307,  -307,  -307,  -307,  -307,  -307,  -307,   -18,
    -307,  -307,  -307,  -307,  -307,   184,  -307,   197,  1283,  -307,
      64,   186,  -307,     1,  -307,   194,   166,   142,  -307,    99,
    -307,  1928,   -17,     0,  1283,  -307,  -307,   842,   587,   524,
    1283,  1048,   124,    33,    33,  -307,   811,  1928,  -307,  1283,
    1283,  1283,  1283,  1283,  1283,  1283,  1283,  1283,  1283,  1283,
    -307,  1283,  1283,  1283,  1283,  1283,  1980,  1283,  1283,  1283,
    1283,  1283,   199,     7,   174,    -8,   204,   206,  -307,   587,
    1329,  -307,  -307,  -307,  -307,   202,   142,   198,  1192,  -307,
    -307,  -307,  -307,  1117,    16,  1928,  1283,   587,  -307,  -307,
    1283,  1986,  1283,  -307,  -307,  1928,   478,   478,   478,   478,
     478,   478,    33,    33,    83,   171,   171,  1283,  2035,    17,
      17,   167,  -307,   596,    74,    74,    74,    74,    74,   205,
     212,  -307,  -307,  1192,     7,  1283,   184,  1213,  -307,  -307,
    1283,   587,  1283,  1283,    44,  -307,   215,  1283,  1928,  -307,
    -307,   227,  1283,  -307,  1504,  -307,  -307,  1853,   596,  1523,
    -307,  1283,  -307,  -307,  -307,  -307,  -307,  -307,  -307,   191,
      15,  -307,  1928,  -307,  -307,  2007,  -307,   219,    39,  1335,
    -307,  -307,  -307,  2028,   152,  -307,  -307,   166,  1551,   216,
     587,  1928,  1283,   587,  1283,  1928,  1283,  1283,  1283,  1283,
    1283,     7,   174,   195,   224,  1283,   923,  -307,   225,   142,
    -307,  1283,  -307,  -307,  -307,  1878,  -307,  -307,  1376,    74,
      74,    74,    74,    74,  -307,     7,   248,   233,   234,   226,
    -307,  1382,   228,   235,   237,  -307,   923,   239,   923,   241,
    -307,  -307,  -307,   587,  1283,  -307,  -307,   224,   224,   587,
    1283,   587,  1283,  1283,  1262,   184,   246,  1283,  -307,  -307,
    1557,  -307,  -307,  -307,  -307,  1903,  -307,  -307,   203,  1423,
     923,  1585,   245,   923,  1429,  1283,   923,   923,  1283,   923,
    1283,  1213,  1283,   923,  1604,  -307,   259,  1632,  1909,   250,
    1470,  1283,   923,  1283,   923,   224,  1283,  1638,  1934,   249,
    1476,  1283,   923,   923,   923,  1666,  1283,  1685,  1283,  1713,
    1283,  1719,  1283,  1747,  1283,  1766,  1283,  1794,  1283,  1800,
    1283,  1828,  1283,  1959,  -307
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -307,  -307,  -307,  -307,  -307,  -307,  -307,    -2,   257,  -307,
      23,  -307,   244,  -307,  -307,   -57,  -307,  -307,  -307,  -307,
    -307,  -307,  -307,  -307,   223,  -307,  -307,   -52,  -240,  -307,
    -307,  -307,  -307,   103,   -29,  -307,  -307,   -66,     8,  -307,
    -307,  -307,  -307,  -285,  -109,  -307,   292,   -76,  -307,  -307,
    -307,   -59,  -307,  -307,    40,  -307,  -307,   114,  -307,  -307,
    -307,  -307,  -307,  -307,  -307,  -307,   -37,  -307,  -307,  -108,
      12,  -130,  -141,  -306,  -307,  -307,  -307,   -30,  -307,  -307,
    -307,     9,  -307,  -307,  -307,  -307,  -307,  -307,   565,  -307,
      22,   -54,  -307,  -307,  -132,   229,  -307,  -307,  -307,  -307,
    -307,  -307,   -26,    24,  -307
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -245
static const short int yytable[] =
{
      13,   176,   192,   193,   100,    69,   305,    50,    34,   334,
     252,     3,   232,    23,    13,   202,   -26,   -28,   -51,   205,
     -53,   221,   295,   243,   172,    16,   105,   253,    60,   222,
     223,   290,   291,   110,   -77,    23,    61,   244,   221,    16,
     312,   100,    19,   313,   162,   232,   222,   223,   224,   225,
      56,   100,     4,     5,     6,     7,     8,     9,    11,    11,
      11,    90,    11,   105,    56,   224,   225,   -77,   344,    10,
     110,   345,   113,   105,   190,   -32,   384,   221,   184,    22,
     110,    53,   224,   225,   185,   222,   223,    20,   241,    28,
     279,   280,   281,   282,   217,   218,   219,   220,    90,   188,
     406,   421,   422,   103,   224,   225,    29,    34,    90,   113,
     209,   210,   211,   212,   213,   214,    36,    37,    11,   113,
      38,    47,   259,   215,   216,   217,   218,   219,   220,   401,
      49,    62,   251,   215,   216,   217,   218,   219,   220,   100,
     103,    30,    31,    32,   310,   218,   219,   220,    65,    67,
     103,   264,   137,    66,   138,    71,    72,   139,   132,   140,
     -35,   105,   221,   299,   125,   338,   133,   -37,   110,   131,
     222,   223,   134,   143,   144,   145,   135,   104,   147,  -244,
     100,   316,   136,   141,    86,    87,    88,    89,   148,   224,
     225,   142,   169,   173,   100,   175,    90,   174,   100,   178,
     179,   195,   105,   183,   187,   189,   235,   113,   196,   110,
     239,   149,   150,   242,   104,   236,   105,   247,   248,   151,
     105,    11,   289,   110,   104,   341,   293,   110,   296,   306,
     437,   297,   303,   225,   330,   220,   329,    90,   103,   346,
     350,   221,   100,   -81,   364,   372,   386,   322,   113,   222,
     223,    90,   400,   409,   412,    90,   160,   407,   408,   433,
     161,   413,   113,   414,   105,   415,   113,   417,   224,   225,
     441,   110,   452,    27,   374,   455,   463,   377,   161,   103,
     428,    51,   162,   163,   164,   165,   166,   167,   168,   129,
     250,   100,   120,   103,   100,   370,   385,   103,   331,    90,
     162,   163,   164,   165,   166,   167,   168,   432,   336,   338,
     113,   449,   104,   105,   459,   333,   105,   402,   368,     0,
     110,     0,     0,   110,     0,     0,   342,   419,     0,   120,
       0,     0,     0,   424,     0,   427,   236,     0,     0,   120,
       0,   103,     0,     0,   100,     0,     0,     0,    90,     0,
     100,    90,   100,   104,     0,    95,   160,     0,     0,   113,
     200,     0,   113,     0,    90,     0,   105,   104,     0,     0,
       0,   104,   105,   110,   105,     0,     0,     0,     0,   110,
       0,   110,   162,   163,   164,   165,   166,   167,   168,     0,
     103,     0,     0,   103,    90,     0,    90,     0,     0,     0,
       0,    90,   177,     0,   387,     0,   103,    90,     0,    90,
       0,     0,   113,     0,     0,   104,     0,     0,   113,     0,
     113,     0,     0,     0,     0,     0,     0,   120,    90,     0,
       0,    90,     0,     0,    90,    90,   103,    90,   103,     0,
       0,    90,     0,   103,     0,     0,     0,   387,   387,   103,
      90,   103,    90,     0,     0,   236,     0,     0,     0,     0,
      90,    90,    90,     0,   104,     0,     0,   104,   120,     0,
     103,     0,     0,   103,     0,     0,   103,   103,   388,   103,
     104,     0,   120,   103,     0,     0,   120,     0,     0,     0,
     258,     0,   103,     0,   103,   387,     0,     0,     0,     0,
       0,     0,   103,   103,   103,     0,     0,     0,     0,     0,
     104,     0,   104,     0,     0,     0,     0,   104,     0,     0,
       0,   388,   388,   104,     0,   104,   211,   212,   213,   214,
     120,   298,     0,     0,     0,     0,     0,   215,   216,   217,
     218,   219,   220,     0,   104,   311,     0,   104,   260,   315,
     104,   104,     0,   104,     0,     0,     0,   104,    39,    40,
      41,    42,    43,    44,    45,     0,   104,     0,   104,   388,
     209,   210,   211,   212,   213,   214,   104,   104,   104,   120,
       0,     0,   120,   215,   216,   217,   218,   219,   220,     0,
      71,    72,     0,   340,     0,   120,    73,    74,    75,    76,
       0,    77,    78,    79,    80,    81,    82,    10,     0,    83,
       0,     0,    84,     0,     0,    49,     0,     0,     0,    86,
      87,    88,    89,     0,     0,   120,     0,   120,     0,     0,
       0,     0,   120,     0,     0,     0,     0,     0,   120,     0,
     120,     0,   373,     0,     0,   376,     0,   155,   322,   323,
     324,   325,   326,   327,   328,     0,    11,     0,   395,   120,
       0,     0,   120,     0,     0,   120,   120,     0,   120,     0,
       0,     0,   120,     0,     0,     0,     0,     0,     0,     0,
       0,   120,     0,   120,     0,     0,   180,     0,     0,     0,
     416,   120,   120,   120,     0,   418,     0,     0,     0,     0,
       0,   423,     0,   426,     0,     0,   197,   199,     0,     0,
       0,     0,   201,     0,   203,   204,     0,   207,     0,     0,
       0,     0,   258,     0,     0,   298,   226,     0,   445,   446,
       0,   315,     0,     0,     0,   340,     0,     0,     0,     0,
       0,     0,     0,   240,   373,     0,   376,     0,     0,     0,
       0,     0,     0,     0,   418,   423,   426,     0,     0,   255,
       0,     0,     0,     0,     0,   261,     0,     0,     0,     0,
       0,   265,     0,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,     0,   278,     0,     0,     0,
       0,     0,   284,   285,   286,   287,   288,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   308,    71,    72,     0,     0,     0,     0,
       0,   314,     0,     0,     0,   317,     0,   319,     0,     0,
       0,     0,   143,   144,   145,     0,     0,   147,     0,     0,
       0,     0,   320,    86,    87,    88,    89,   148,     0,     0,
      -9,    -9,    -9,    -9,    -9,    -9,    -9,     0,   332,     0,
     335,     0,     0,     0,     0,   339,   256,   180,   343,   257,
     149,   150,   348,     0,     0,     0,     0,   351,   151,    -9,
      11,    -9,    -9,    -9,     0,     0,   355,     0,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,   215,   216,   217,   218,   219,   220,     0,     0,   180,
       0,     0,     0,     0,     0,     0,     0,   375,     0,   378,
       0,   379,   380,   381,   382,   383,    71,    72,     0,     0,
     391,     0,    73,    74,   392,    76,   348,    77,    78,    79,
     393,   394,    82,    10,     0,    83,     0,     0,    84,     0,
       0,    49,     0,     0,     0,    86,    87,    88,    89,     0,
       0,     0,     0,     0,     0,     0,    71,    72,     0,   420,
       0,     0,     0,     0,     0,   425,     0,     0,   429,   431,
       0,     0,   434,     0,   143,   144,   145,     0,   146,   147,
       0,     0,    11,     0,     0,    86,    87,    88,    89,   148,
     444,     0,     0,   447,     0,   448,     0,   450,     0,     0,
       0,     0,     0,     0,     0,     0,   457,     0,   458,     0,
       0,   460,   149,   150,     0,     0,   465,     0,     0,     0,
     151,   467,    11,   469,     0,   471,     0,   473,     0,   475,
       0,   477,     0,   479,     0,   481,    70,   483,    71,    72,
       0,     0,     0,     0,    73,    74,    75,    76,     0,    77,
      78,    79,    80,    81,    82,    10,     0,    83,     0,     0,
      84,     0,   262,    49,    85,   263,     0,    86,    87,    88,
      89,     0,     0,     0,    -9,    -9,    -9,    -9,    -9,    -9,
      -9,     0,     0,     0,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,     0,   215,   216,   217,
     218,   219,   220,    -9,    11,    -9,    -9,    -9,    70,     0,
      71,    72,     0,     0,     0,     0,    73,    74,    75,    76,
       0,    77,    78,    79,    80,    81,    82,    10,     0,    83,
       0,     0,    84,     0,     0,    49,    71,    72,     0,    86,
      87,    88,    89,     0,     0,     0,    -9,    -9,    -9,    -9,
      -9,    -9,    -9,     0,   143,   144,   145,     0,     0,   147,
     198,     0,     0,     0,     0,    86,    87,    88,    89,   148,
       0,     0,     0,     0,     0,    -9,    11,    -9,    -9,    -9,
       0,     0,     0,     0,     0,    71,    72,     0,     0,     0,
       0,     0,   149,   150,     0,     0,     0,     0,     0,     0,
     151,     0,    11,   143,   144,   145,    71,    72,   147,     0,
     307,     0,     0,     0,    86,    87,    88,    89,   148,     0,
       0,     0,     0,     0,   143,   144,   145,     0,  -155,   147,
       0,     0,     0,     0,     0,    86,    87,    88,    89,   148,
       0,   149,   150,     0,     0,     0,     0,     0,     0,   151,
       0,    11,     0,     0,     0,    71,    72,     0,     0,     0,
       0,     0,   149,   150,     0,     0,     0,     0,     0,     0,
     151,     0,    11,   143,   144,   145,    71,    72,   147,   430,
       0,     0,     0,     0,    86,    87,    88,    89,   148,     0,
       0,     0,     0,     0,   143,   144,   145,    71,    72,   147,
       0,     0,     0,     0,     0,    86,    87,    88,    89,   148,
       0,   149,   150,     0,     0,   143,   144,   145,     0,   151,
     147,    11,     0,     0,     0,     0,    86,    87,    88,    89,
     206,     0,   149,   150,     0,     0,     0,     0,     0,     0,
     151,     0,    11,   300,     0,     0,   301,     0,     0,   365,
       0,     0,   366,   149,   150,     0,     0,     0,     0,     0,
       0,   151,     0,    11,     0,   209,   210,   211,   212,   213,
     214,   209,   210,   211,   212,   213,   214,     0,   215,   216,
     217,   218,   219,   220,   215,   216,   217,   218,   219,   220,
     404,     0,     0,   405,     0,     0,   410,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   209,   210,   211,   212,   213,   214,   209,   210,
     211,   212,   213,   214,     0,   215,   216,   217,   218,   219,
     220,   215,   216,   217,   218,   219,   220,   438,     0,     0,
     439,     0,     0,   442,     0,     0,   443,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
     210,   211,   212,   213,   214,   209,   210,   211,   212,   213,
     214,     0,   215,   216,   217,   218,   219,   220,   215,   216,
     217,   218,   219,   220,   456,     0,     0,   366,     0,     0,
     410,     0,     0,   464,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   209,   210,   211,   212,
     213,   214,   209,   210,   211,   212,   213,   214,   352,   215,
     216,   217,   218,   219,   220,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,   354,     0,     0,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,   215,   216,   217,   218,   219,   220,   209,
     210,   211,   212,   213,   214,   371,     0,     0,     0,     0,
       0,   435,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   209,   210,   211,
     212,   213,   214,   209,   210,   211,   212,   213,   214,   440,
     215,   216,   217,   218,   219,   220,   215,   216,   217,   218,
     219,   220,     0,     0,     0,     0,     0,     0,   451,     0,
       0,   209,   210,   211,   212,   213,   214,     0,     0,     0,
       0,     0,     0,     0,   215,   216,   217,   218,   219,   220,
     209,   210,   211,   212,   213,   214,   453,     0,     0,     0,
       0,     0,   461,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   209,   210,
     211,   212,   213,   214,   209,   210,   211,   212,   213,   214,
     466,   215,   216,   217,   218,   219,   220,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,   468,
       0,     0,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,   215,   216,   217,   218,   219,
     220,   209,   210,   211,   212,   213,   214,   470,     0,     0,
       0,     0,     0,   472,   215,   216,   217,   218,   219,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
     210,   211,   212,   213,   214,   209,   210,   211,   212,   213,
     214,   474,   215,   216,   217,   218,   219,   220,   215,   216,
     217,   218,   219,   220,     0,     0,     0,     0,     0,     0,
     476,     0,     0,   209,   210,   211,   212,   213,   214,     0,
       0,     0,     0,     0,     0,     0,   215,   216,   217,   218,
     219,   220,   209,   210,   211,   212,   213,   214,   478,     0,
       0,     0,     0,     0,   480,   215,   216,   217,   218,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     209,   210,   211,   212,   213,   214,   209,   210,   211,   212,
     213,   214,   482,   215,   216,   217,   218,   219,   220,   215,
     216,   217,   218,   219,   220,     0,     0,     0,     0,     0,
       0,     0,   208,     0,   209,   210,   211,   212,   213,   214,
     353,     0,     0,     0,     0,     0,     0,   215,   216,   217,
     218,   219,   220,   209,   210,   211,   212,   213,   214,   209,
     210,   211,   212,   213,   214,   403,   215,   216,   217,   218,
     219,   220,   215,   216,   217,   218,   219,   220,     0,     0,
       0,     0,     0,     0,   209,   210,   211,   212,   213,   214,
     436,     0,     0,     0,     0,     0,   454,   215,   216,   217,
     218,   219,   220,     0,     0,     0,     0,     0,     0,   209,
     210,   211,   212,   213,   214,   209,   210,   211,   212,   213,
     214,   462,   215,   216,   217,   218,   219,   220,   215,   216,
     217,   218,   219,   220,   209,   210,   211,   212,   213,   214,
     209,   210,   211,   212,   213,   214,   484,   215,   216,   217,
     218,   219,   220,   215,   216,   217,   218,   219,   220,     0,
       0,     0,     0,     0,     0,   209,   210,   211,   212,   213,
     214,   283,     0,     0,     0,     0,     0,   318,   215,   216,
     217,   218,   219,   220,     0,     0,   209,   210,   211,   212,
     213,   214,   209,   210,   211,   212,   213,   214,   363,   215,
     216,   217,   218,   219,   220,   215,   216,   217,   218,   219,
     220,     0,     0,   209,   210,   211,   212,   213,   214,   367,
       0,     0,     0,     0,     0,     0,   215,   216,   217,   218,
     219,   220,   321,     0,   209,   210,   211,   212,   213,   214,
       0,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,     0,   215,   216,   217,   218,   219,   220
};

static const short int yycheck[] =
{
       2,   110,   134,   135,    63,    62,   246,    36,    26,   294,
      27,     0,    30,    15,    16,   147,    27,    27,    27,   151,
      27,    38,    30,    22,   100,     2,    63,    27,    23,    46,
      47,    24,    25,    63,    52,    37,    31,    36,    38,    16,
      24,   100,    22,    27,    52,    30,    46,    47,    65,    66,
      52,   110,     3,     4,     5,     6,     7,     8,    69,    69,
      69,    63,    69,   100,    66,    65,    66,    52,    24,    20,
     100,    27,    63,   110,   131,    24,   361,    38,    24,    22,
     110,    30,    65,    66,    30,    46,    47,    68,    24,    22,
     222,   223,   224,   225,    61,    62,    63,    64,   100,   128,
     385,   407,   408,    63,    65,    66,    26,    26,   110,   100,
      46,    47,    48,    49,    50,    51,    27,    25,    69,   110,
      26,    22,   198,    59,    60,    61,    62,    63,    64,   369,
      28,    24,   189,    59,    60,    61,    62,    63,    64,   198,
     100,    70,    71,    72,   253,    62,    63,    64,    27,    31,
     110,    27,    23,    25,    25,     3,     4,    23,    26,    25,
      24,   198,    38,   239,    22,   297,    26,    24,   198,    24,
      46,    47,    26,    21,    22,    23,    26,    63,    26,    27,
     239,   257,    26,    26,    32,    33,    34,    35,    36,    65,
      66,    26,    22,    25,   253,    26,   198,    25,   257,    26,
      25,    25,   239,    26,    24,    24,    22,   198,    25,   239,
      13,    59,    60,    27,   100,   175,   253,    23,    52,    67,
     257,    69,    23,   253,   110,   301,    52,   257,    24,    31,
      27,    25,    30,    66,    22,    64,    31,   239,   198,    24,
      13,    38,   301,    52,    25,    29,    22,    52,   239,    46,
      47,   253,    27,    27,    26,   257,    26,    24,    24,    13,
      30,    26,   253,    26,   301,    26,   257,    26,    65,    66,
      25,   301,    13,    16,   350,    25,    27,   353,    30,   239,
     412,    37,    52,    53,    54,    55,    56,    57,    58,    66,
     187,   350,    63,   253,   353,   347,   362,   257,   290,   301,
      52,    53,    54,    55,    56,    57,    58,   415,   296,   441,
     301,   441,   198,   350,   455,   293,   353,   371,   344,    -1,
     350,    -1,    -1,   353,    -1,    -1,   302,   403,    -1,   100,
      -1,    -1,    -1,   409,    -1,   411,   296,    -1,    -1,   110,
      -1,   301,    -1,    -1,   403,    -1,    -1,    -1,   350,    -1,
     409,   353,   411,   239,    -1,    63,    26,    -1,    -1,   350,
      30,    -1,   353,    -1,   366,    -1,   403,   253,    -1,    -1,
      -1,   257,   409,   403,   411,    -1,    -1,    -1,    -1,   409,
      -1,   411,    52,    53,    54,    55,    56,    57,    58,    -1,
     350,    -1,    -1,   353,   396,    -1,   398,    -1,    -1,    -1,
      -1,   403,   110,    -1,   364,    -1,   366,   409,    -1,   411,
      -1,    -1,   403,    -1,    -1,   301,    -1,    -1,   409,    -1,
     411,    -1,    -1,    -1,    -1,    -1,    -1,   198,   430,    -1,
      -1,   433,    -1,    -1,   436,   437,   396,   439,   398,    -1,
      -1,   443,    -1,   403,    -1,    -1,    -1,   407,   408,   409,
     452,   411,   454,    -1,    -1,   415,    -1,    -1,    -1,    -1,
     462,   463,   464,    -1,   350,    -1,    -1,   353,   239,    -1,
     430,    -1,    -1,   433,    -1,    -1,   436,   437,   364,   439,
     366,    -1,   253,   443,    -1,    -1,   257,    -1,    -1,    -1,
     198,    -1,   452,    -1,   454,   455,    -1,    -1,    -1,    -1,
      -1,    -1,   462,   463,   464,    -1,    -1,    -1,    -1,    -1,
     396,    -1,   398,    -1,    -1,    -1,    -1,   403,    -1,    -1,
      -1,   407,   408,   409,    -1,   411,    48,    49,    50,    51,
     301,   239,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    64,    -1,   430,   253,    -1,   433,    24,   257,
     436,   437,    -1,   439,    -1,    -1,    -1,   443,    39,    40,
      41,    42,    43,    44,    45,    -1,   452,    -1,   454,   455,
      46,    47,    48,    49,    50,    51,   462,   463,   464,   350,
      -1,    -1,   353,    59,    60,    61,    62,    63,    64,    -1,
       3,     4,    -1,   301,    -1,   366,     9,    10,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    25,    -1,    -1,    28,    -1,    -1,    -1,    32,
      33,    34,    35,    -1,    -1,   396,    -1,   398,    -1,    -1,
      -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,   409,    -1,
     411,    -1,   350,    -1,    -1,   353,    -1,    82,    52,    53,
      54,    55,    56,    57,    58,    -1,    69,    -1,   366,   430,
      -1,    -1,   433,    -1,    -1,   436,   437,    -1,   439,    -1,
      -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   452,    -1,   454,    -1,    -1,   121,    -1,    -1,    -1,
     398,   462,   463,   464,    -1,   403,    -1,    -1,    -1,    -1,
      -1,   409,    -1,   411,    -1,    -1,   141,   142,    -1,    -1,
      -1,    -1,   147,    -1,   149,   150,    -1,   152,    -1,    -1,
      -1,    -1,   430,    -1,    -1,   433,   161,    -1,   436,   437,
      -1,   439,    -1,    -1,    -1,   443,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   178,   452,    -1,   454,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   462,   463,   464,    -1,    -1,   194,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,    -1,    -1,
      -1,    -1,   227,   228,   229,   230,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   248,     3,     4,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,   260,    -1,   262,    -1,    -1,
      -1,    -1,    21,    22,    23,    -1,    -1,    26,    -1,    -1,
      -1,    -1,   277,    32,    33,    34,    35,    36,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,   300,    24,   302,   303,    27,
      59,    60,   307,    -1,    -1,    -1,    -1,   312,    67,    68,
      69,    70,    71,    72,    -1,    -1,   321,    -1,    46,    47,
      48,    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    64,    -1,    -1,   344,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,   354,
      -1,   356,   357,   358,   359,   360,     3,     4,    -1,    -1,
     365,    -1,     9,    10,    11,    12,   371,    14,    15,    16,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    25,    -1,
      -1,    28,    -1,    -1,    -1,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,   404,
      -1,    -1,    -1,    -1,    -1,   410,    -1,    -1,   413,   414,
      -1,    -1,   417,    -1,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    69,    -1,    -1,    32,    33,    34,    35,    36,
     435,    -1,    -1,   438,    -1,   440,    -1,   442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   451,    -1,   453,    -1,
      -1,   456,    59,    60,    -1,    -1,   461,    -1,    -1,    -1,
      67,   466,    69,   468,    -1,   470,    -1,   472,    -1,   474,
      -1,   476,    -1,   478,    -1,   480,     1,   482,     3,     4,
      -1,    -1,    -1,    -1,     9,    10,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      25,    -1,    24,    28,    29,    27,    -1,    32,    33,    34,
      35,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    -1,    -1,    46,    47,    48,    49,    50,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    64,    68,    69,    70,    71,    72,     1,    -1,
       3,     4,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    25,    -1,    -1,    28,     3,     4,    -1,    32,
      33,    34,    35,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    -1,    21,    22,    23,    -1,    -1,    26,
      27,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    69,    21,    22,    23,     3,     4,    26,    -1,
      28,    -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    -1,    25,    26,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    69,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    69,    21,    22,    23,     3,     4,    26,    27,
      -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,     3,     4,    26,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    59,    60,    -1,    -1,    21,    22,    23,    -1,    67,
      26,    69,    -1,    -1,    -1,    -1,    32,    33,    34,    35,
      36,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    69,    24,    -1,    -1,    27,    -1,    -1,    24,
      -1,    -1,    27,    59,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    69,    -1,    46,    47,    48,    49,    50,
      51,    46,    47,    48,    49,    50,    51,    -1,    59,    60,
      61,    62,    63,    64,    59,    60,    61,    62,    63,    64,
      24,    -1,    -1,    27,    -1,    -1,    24,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    47,    48,    49,    50,    51,    46,    47,
      48,    49,    50,    51,    -1,    59,    60,    61,    62,    63,
      64,    59,    60,    61,    62,    63,    64,    24,    -1,    -1,
      27,    -1,    -1,    24,    -1,    -1,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    50,    51,    46,    47,    48,    49,    50,
      51,    -1,    59,    60,    61,    62,    63,    64,    59,    60,
      61,    62,    63,    64,    24,    -1,    -1,    27,    -1,    -1,
      24,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    46,    47,    48,    49,
      50,    51,    46,    47,    48,    49,    50,    51,    24,    59,
      60,    61,    62,    63,    64,    59,    60,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      46,    47,    48,    49,    50,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    64,    46,
      47,    48,    49,    50,    51,    24,    -1,    -1,    -1,    -1,
      -1,    24,    59,    60,    61,    62,    63,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,    48,
      49,    50,    51,    46,    47,    48,    49,    50,    51,    24,
      59,    60,    61,    62,    63,    64,    59,    60,    61,    62,
      63,    64,    -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,
      -1,    46,    47,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    60,    61,    62,    63,    64,
      46,    47,    48,    49,    50,    51,    24,    -1,    -1,    -1,
      -1,    -1,    24,    59,    60,    61,    62,    63,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,
      48,    49,    50,    51,    46,    47,    48,    49,    50,    51,
      24,    59,    60,    61,    62,    63,    64,    59,    60,    61,
      62,    63,    64,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    46,    47,    48,    49,    50,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,    63,
      64,    46,    47,    48,    49,    50,    51,    24,    -1,    -1,
      -1,    -1,    -1,    24,    59,    60,    61,    62,    63,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    50,    51,    46,    47,    48,    49,    50,
      51,    24,    59,    60,    61,    62,    63,    64,    59,    60,
      61,    62,    63,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    46,    47,    48,    49,    50,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    64,    46,    47,    48,    49,    50,    51,    24,    -1,
      -1,    -1,    -1,    -1,    24,    59,    60,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    47,    48,    49,    50,    51,    46,    47,    48,    49,
      50,    51,    24,    59,    60,    61,    62,    63,    64,    59,
      60,    61,    62,    63,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    46,    47,    48,    49,    50,    51,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    64,    46,    47,    48,    49,    50,    51,    46,
      47,    48,    49,    50,    51,    27,    59,    60,    61,    62,
      63,    64,    59,    60,    61,    62,    63,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    47,    48,    49,    50,    51,
      27,    -1,    -1,    -1,    -1,    -1,    27,    59,    60,    61,
      62,    63,    64,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    50,    51,    46,    47,    48,    49,    50,
      51,    27,    59,    60,    61,    62,    63,    64,    59,    60,
      61,    62,    63,    64,    46,    47,    48,    49,    50,    51,
      46,    47,    48,    49,    50,    51,    27,    59,    60,    61,
      62,    63,    64,    59,    60,    61,    62,    63,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    47,    48,    49,    50,
      51,    31,    -1,    -1,    -1,    -1,    -1,    31,    59,    60,
      61,    62,    63,    64,    -1,    -1,    46,    47,    48,    49,
      50,    51,    46,    47,    48,    49,    50,    51,    31,    59,
      60,    61,    62,    63,    64,    59,    60,    61,    62,    63,
      64,    -1,    -1,    46,    47,    48,    49,    50,    51,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    64,    37,    -1,    46,    47,    48,    49,    50,    51,
      -1,    46,    47,    48,    49,    50,    51,    59,    60,    61,
      62,    63,    64,    -1,    59,    60,    61,    62,    63,    64
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    74,    75,     0,     3,     4,     5,     6,     7,     8,
      20,    69,    77,    80,    81,    82,    83,    92,    95,    22,
      68,    78,    22,    80,    84,    85,    86,    81,    22,    26,
      70,    71,    72,    76,    26,    87,    27,    25,    26,    39,
      40,    41,    42,    43,    44,    45,    79,    22,    88,    28,
     107,    85,    93,    30,    89,   108,    80,    96,    97,    98,
      23,    31,    24,   118,    99,    27,    25,    31,    90,    88,
       1,     3,     4,     9,    10,    11,    12,    14,    15,    16,
      17,    18,    19,    22,    25,    29,    32,    33,    34,    35,
      80,    83,   107,   109,   117,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   130,   139,   140,   141,   147,   148,
     150,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     168,   169,   170,   173,   174,    22,   101,   106,    94,    97,
      91,    24,    26,    26,    26,    26,    26,    23,    25,    23,
      25,    26,    26,    21,    22,    23,    25,    26,    36,    59,
      60,    67,    80,   127,   130,   161,   165,   166,   167,   168,
      26,    30,    52,    53,    54,    55,    56,    57,    58,    22,
     111,   119,   120,    25,    25,    26,   117,   119,    26,    25,
     161,   175,   176,    26,    24,    30,   103,    24,   107,    24,
      88,   161,   167,   167,   151,    25,    25,   161,    27,   161,
      30,   161,   167,   161,   161,   167,    36,   161,    25,    46,
      47,    48,    49,    50,    51,    59,    60,    61,    62,    63,
      64,    38,    46,    47,    65,    66,   161,   128,   132,   131,
     134,   133,    30,   112,   113,    22,   127,   142,   143,    13,
     161,    24,    27,    22,    36,   171,   102,    23,    52,   100,
     106,    88,    27,    27,   149,   161,    24,    27,   119,   120,
      24,   161,    24,    27,    27,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   162,   161,   167,
     167,   167,   167,    31,   161,   161,   161,   161,   161,    23,
      24,    25,   116,    52,   110,    30,    24,    25,   119,   120,
      24,    27,   177,    30,   172,   101,    31,    28,   161,   163,
     117,   119,    24,    27,   161,   119,   120,   161,    31,   161,
     161,    37,    52,    53,    54,    55,    56,    57,    58,    31,
      22,   111,   161,   163,   116,   161,   143,   144,   167,   161,
     119,   120,   176,   161,    24,    27,    24,   105,   161,   164,
      13,   161,    24,    27,    24,   161,   129,   136,   135,   138,
     137,   114,   115,    31,    25,    24,    27,    31,   175,   104,
     100,    24,    29,   119,   120,   161,   119,   120,   161,   161,
     161,   161,   161,   161,   116,   110,    22,   127,   130,   145,
     146,   161,    11,    17,    18,   119,   124,   139,   150,   154,
      27,   101,   164,    27,    24,    27,   116,    24,    24,    27,
      24,    27,    26,    26,    26,    26,   119,    26,   119,   120,
     161,   146,   146,   119,   120,   161,   119,   120,   167,   161,
      27,   161,   142,    13,   161,    24,    27,    27,    24,    27,
      24,    25,    24,    27,   161,   119,   119,   161,   161,   144,
     161,    24,    13,    24,    27,    25,    24,   161,   161,   145,
     161,    24,    27,    27,    27,   161,    24,   161,    24,   161,
      24,   161,    24,   161,    24,   161,    24,   161,    24,   161,
      24,   161,    24,   161,    27
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 247 "sl.y"
    {
			;}
    break;

  case 3:
#line 250 "sl.y"
    {
			;}
    break;

  case 4:
#line 256 "sl.y"
    {
				yyval.integer	=	SLC_UNIFORM;
			;}
    break;

  case 5:
#line 261 "sl.y"
    {
				yyval.integer	=	SLC_VARYING;
			;}
    break;

  case 6:
#line 266 "sl.y"
    {
				yyval.integer	=	SLC_VARYING | SLC_VERTEX;
			;}
    break;

  case 7:
#line 270 "sl.y"
    {
				yyval.integer	=	0;
			;}
    break;

  case 8:
#line 278 "sl.y"
    {
				yyval.integer	=	SLC_EXTERN;
			;}
    break;

  case 9:
#line 282 "sl.y"
    {
				yyval.integer	=	0;
			;}
    break;

  case 10:
#line 289 "sl.y"
    {
				yyval.integer	=	SLC_OUTPUT;
			;}
    break;

  case 11:
#line 293 "sl.y"
    {
				yyval.integer	=	0;
			;}
    break;

  case 12:
#line 300 "sl.y"
    {
				yyval.integer	=	SLC_FLOAT;
			;}
    break;

  case 13:
#line 305 "sl.y"
    {
				yyval.integer	=	SLC_VECTOR | SLC_VCOLOR;
			;}
    break;

  case 14:
#line 310 "sl.y"
    {
				yyval.integer	=	SLC_VECTOR | SLC_VVECTOR;
			;}
    break;

  case 15:
#line 315 "sl.y"
    {
				yyval.integer	=	SLC_VECTOR | SLC_VNORMAL;
			;}
    break;

  case 16:
#line 320 "sl.y"
    {
				yyval.integer	=	SLC_VECTOR | SLC_VPOINT;
			;}
    break;

  case 17:
#line 325 "sl.y"
    {
				yyval.integer	=	SLC_MATRIX;
			;}
    break;

  case 18:
#line 330 "sl.y"
    {
				yyval.integer	=	SLC_STRING | SLC_UNIFORM;
			;}
    break;

  case 19:
#line 340 "sl.y"
    {
				yyval.integer	=	yyvsp[-3].integer | yyvsp[-2].integer | yyvsp[-1].integer | yyvsp[0].integer;
				sdr->desire(yyval.integer);
			;}
    break;

  case 20:
#line 358 "sl.y"
    {
		;}
    break;

  case 21:
#line 362 "sl.y"
    {
		;}
    break;

  case 22:
#line 379 "sl.y"
    {
			CFunction	*thisFunction	=	sdr->newFunction(yyvsp[-1].string);
			
			if (yyvsp[-2].integer & (SLC_OUTPUT | SLC_EXTERN | SLC_RDONLY)) {
				sdr->error("Invalid return type for function %s\n",yyvsp[-1].string);
				yyvsp[-2].integer	&=	~(SLC_OUTPUT | SLC_EXTERN | SLC_RDONLY);
			}

			thisFunction->returnValue	=	new CParameter(yyvsp[-1].string,yyvsp[-2].integer,1);

			sdr->undesire();
		;}
    break;

  case 23:
#line 395 "sl.y"
    {
			CFunction	*thisFunction	=	sdr->newFunction(yyvsp[-1].string);
			
			thisFunction->returnValue	=	NULL;
		;}
    break;

  case 24:
#line 407 "sl.y"
    {
			CFunction	*cFun		=	sdr->popFunction();

			cFun->initExpression	=	yyvsp[-2].code;
			cFun->code				=	yyvsp[0].code;

			if (cFun->returnValue != NULL)
				if (cFun->returnValueGiven == FALSE) 
					sdr->error("Return value not given for %s\n",cFun->symbolName);

		;}
    break;

  case 25:
#line 425 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 26:
#line 429 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 27:
#line 441 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 28:
#line 447 "sl.y"
    {
			yyval.code	=	yyvsp[-1].code;
		;}
    break;

  case 29:
#line 452 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 30:
#line 461 "sl.y"
    {
			int	type	=	sdr->desired();

			if (type & (SLC_EXTERN)) {
				sdr->error("Invalid parameter type\n");
				type	&=	~(SLC_EXTERN);
			}

			if (type & SLC_OUTPUT) {
				sdr->undesire();
				sdr->desire(type);					// Make sure we mark the desired type as READ-ONLY
			} else {
				sdr->undesire();
				sdr->desire(type | SLC_RDONLY);		// Make sure we mark the desired type as READ-ONLY
			}
		;}
    break;

  case 31:
#line 478 "sl.y"
    {
			yyval.code					=	yyvsp[0].code;
			sdr->undesire();						// We're done with the type
		;}
    break;

  case 32:
#line 488 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[0].string,sdr->desired(),1);	// Add the Parameter to the current CFunction
		;}
    break;

  case 33:
#line 495 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 34:
#line 500 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[0].string,sdr->desired(),1);
	
			yyval.code			=	new CNullExpression;
		;}
    break;

  case 35:
#line 511 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[-2].string,sdr->desired() | SLC_ARRAY,-1);
		;}
    break;

  case 36:
#line 518 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 37:
#line 526 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[-3].string,sdr->desired() | SLC_ARRAY, atoi(yyvsp[-1].string));
			
			if (cParameter->numItems <= 0) {
				sdr->error("Array size for %s is invalid (%s)\n",yyvsp[-3].string,yyvsp[-1].string);
				cParameter->numItems	=	1;
			}
		;}
    break;

  case 38:
#line 538 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 39:
#line 545 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[-2].string,sdr->desired() | SLC_ARRAY, -1);
			
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 40:
#line 557 "sl.y"
    {
			CParameter	*cParameter;
			
			cParameter	=	sdr->newParameter(yyvsp[-3].string,sdr->desired() | SLC_ARRAY, atoi(yyvsp[-1].string));
			
			if (cParameter->numItems <= 0) {
				sdr->error("Array size for %s is invalid (%s)\n",yyvsp[-3].string,yyvsp[-1].string);
				cParameter->numItems	=	1;
			}

			yyval.code	=	new CNullExpression;
		;}
    break;

  case 41:
#line 578 "sl.y"
    {
			CFunction		*mainFunction	=	sdr->newFunction(constantShaderMain);

			mainFunction->returnValue		=	NULL;

			sdr->shaderName					=	strdup(yyvsp[-1].string);
			sdr->shaderType					=	yyvsp[-2].integer;
			sdr->shaderFunction				=	mainFunction;
		;}
    break;

  case 42:
#line 589 "sl.y"
    {
			sdr->restoreParameters();
		;}
    break;

  case 43:
#line 593 "sl.y"
    {
			CFunction	*cFun			=	sdr->popFunction();
			CParameter	*cParameter;

			for (cParameter=cFun->parameters->first();cParameter!=NULL;cParameter=cFun->parameters->next()) {
				sdr->variables->push(cParameter);
			}

			assert(cFun == sdr->shaderFunction);

			cFun->initExpression	=	yyvsp[-3].code;
			cFun->code				=	yyvsp[0].code;
		;}
    break;

  case 44:
#line 611 "sl.y"
    {
			yyval.integer	=	SLC_SURFACE;
		;}
    break;

  case 45:
#line 616 "sl.y"
    {
			yyval.integer	=	SLC_DISPLACEMENT;
		;}
    break;

  case 46:
#line 621 "sl.y"
    {
			yyval.integer	=	SLC_LIGHT;
		;}
    break;

  case 47:
#line 626 "sl.y"
    {
			yyval.integer	=	SLC_VOLUME;
		;}
    break;

  case 48:
#line 631 "sl.y"
    {
			yyval.integer	=	SLC_TRANSFORMATION;
		;}
    break;

  case 49:
#line 636 "sl.y"
    {
			yyval.integer	=	SLC_IMAGER;
		;}
    break;

  case 50:
#line 645 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 51:
#line 649 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 52:
#line 660 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 53:
#line 666 "sl.y"
    {
			yyval.code	=	yyvsp[-1].code;
		;}
    break;

  case 54:
#line 671 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 55:
#line 680 "sl.y"
    {
			int	type	=	yyvsp[0].integer;

			if (type & SLC_VARYING) {
			} else {
				type |= SLC_UNIFORM;
			}

			// FIXME: Shaders have uniform variables only
			//type |= SLC_UNIFORM;

			sdr->undesire();
			sdr->desire(type);
		;}
    break;

  case 56:
#line 695 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		
			if (yyvsp[-2].integer & (SLC_EXTERN)) {
				sdr->error("Invalid parameter type for the shader\n");
			}

			sdr->undesire();
		;}
    break;

  case 57:
#line 711 "sl.y"
    {
			//if (!(sdr->desired() & SLC_VARYING)) {
				yyval.code	=	getAssignment(sdr->variableList,yyvsp[0].expression);
			//} else {
			//	CVariable	*cVar;

			//	while((cVar = sdr->variableList->pop()) != NULL) {
			//	}
			//	$$	=	new CNullExpression;
			//}
		;}
    break;

  case 58:
#line 725 "sl.y"
    {
			//if (!(sdr->desired() & SLC_VARYING))
				yyval.code	=	getAssignment(sdr->variableList,yyvsp[0].array);
			//else {
			//	CVariable	*cVar;

			//	while((cVar = sdr->variableList->pop()) != NULL) {
			//	}

			//	$$	=	new CNullExpression;
			//}
		;}
    break;

  case 59:
#line 743 "sl.y"
    {
			CParameter	*cParameter	=	sdr->newParameter(yyvsp[-1].string,sdr->desired() | SLC_PARAMETER,1);

			sdr->variableList->push(cParameter);	// Save the parameter so that we can generate init code later
		;}
    break;

  case 60:
#line 749 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 61:
#line 754 "sl.y"
    {
			CParameter	*cParameter	=	sdr->newParameter(yyvsp[0].string,sdr->desired() | SLC_PARAMETER,1);

			sdr->variableList->push(cParameter);
		;}
    break;

  case 62:
#line 760 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 63:
#line 769 "sl.y"
    {
			CParameter	*cParameter	=	sdr->newParameter(yyvsp[-4].string,sdr->desired() | SLC_PARAMETER | SLC_ARRAY,atoi(yyvsp[-2].string));

			if (cParameter->numItems <= 0) {
				sdr->error("Array size for %s is invalid (%s)\n",yyvsp[-4].string,yyvsp[-2].string);
				cParameter->numItems	=	1;
			}

			sdr->variableList->push(cParameter);
		;}
    break;

  case 64:
#line 780 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 65:
#line 788 "sl.y"
    {
			CParameter	*cParameter	=	sdr->newParameter(yyvsp[-3].string,sdr->desired() | SLC_PARAMETER | SLC_ARRAY,atoi(yyvsp[-1].string));

			// Get the parameter
			if (cParameter->numItems <= 0)	{
				sdr->error("Array size for %s is invalid (%s)\n",yyvsp[-3].string,yyvsp[-1].string);
				cParameter->numItems	=	1;
			}

			sdr->variableList->push(cParameter);
		;}
    break;

  case 66:
#line 800 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 67:
#line 805 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 68:
#line 813 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 69:
#line 820 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 70:
#line 830 "sl.y"
    {
			CFunction	*cFun	=	sdr->newFunction(constantBlockName);
		;}
    break;

  case 71:
#line 835 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			cFun->code			=	yyvsp[-1].code;

			yyval.code	=	new	CFuncallExpression(cFun,NULL);
		;}
    break;

  case 72:
#line 851 "sl.y"
    {
			CVariable	*cVar;

			if (yyvsp[-1].integer & (SLC_OUTPUT | SLC_RDONLY)) {
				sdr->error("Invalid container class for local variables\n");
			}

			// Remove the uninitialized variables from the list
			while((cVar = (CVariable *) sdr->variableList->pop()) != NULL);

			sdr->undesire();

			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 73:
#line 872 "sl.y"
    {
			yyval.code	=	getAssignment(sdr->variableList,yyvsp[0].expression);
		;}
    break;

  case 74:
#line 878 "sl.y"
    {
			yyval.code	=	getAssignment(sdr->variableList,yyvsp[0].array);
		;}
    break;

  case 75:
#line 885 "sl.y"
    {
			CVariable	*cVar;

			cVar	=	sdr->newVariable(yyvsp[0].string,sdr->desired(),1);

			sdr->variableList->push(cVar);
		;}
    break;

  case 76:
#line 893 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 77:
#line 898 "sl.y"
    {
			CVariable	*cVar;

			cVar	=	sdr->newVariable(yyvsp[0].string,sdr->desired(),1);

			sdr->variableList->push(cVar);
		;}
    break;

  case 78:
#line 907 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-1].code,yyvsp[0].code);
		;}
    break;

  case 79:
#line 916 "sl.y"
    {
			CVariable	*cVar;

			cVar	=	sdr->newVariable(yyvsp[-3].string,sdr->desired() | SLC_ARRAY,atoi(yyvsp[-1].string));

			if (cVar->numItems <= 0) {
				sdr->error("Array size is invalid for %s (%s)\n",yyvsp[-3].string,yyvsp[-1].string);
				cVar->numItems	=	1;
			}

			sdr->variableList->push(cVar);
		;}
    break;

  case 80:
#line 929 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 81:
#line 937 "sl.y"
    {
			CVariable	*cVar;

			cVar	=	sdr->newVariable(yyvsp[-3].string,sdr->desired() | SLC_ARRAY,atoi(yyvsp[-1].string));

		
			if (cVar->numItems <= 0) {
				sdr->error("Array size is invalid for %s (%s)\n",yyvsp[-3].string,yyvsp[-1].string);
				cVar->numItems	=	1;
			}

			sdr->variableList->push(cVar);
		;}
    break;

  case 82:
#line 953 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-1].code,yyvsp[0].code);
		;}
    break;

  case 83:
#line 961 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 84:
#line 966 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 85:
#line 976 "sl.y"
    {

			yyval.code	=	yyvsp[0].code;
			assert(sdr->desired() & SLC_NONE);
		;}
    break;

  case 86:
#line 983 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
			assert(sdr->desired() & SLC_NONE);
		;}
    break;

  case 87:
#line 989 "sl.y"
    {
			// Recoverable error happened
			yyval.code	=	new CNullExpression;
			assert(sdr->desired() & SLC_NONE);
		;}
    break;

  case 88:
#line 1000 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-1].code,yyvsp[0].code);
		;}
    break;

  case 89:
#line 1004 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 90:
#line 1014 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 91:
#line 1019 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 92:
#line 1024 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 93:
#line 1029 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 94:
#line 1034 "sl.y"
    {
			yyval.code	=	yyvsp[-1].expression;
		;}
    break;

  case 95:
#line 1039 "sl.y"
    {
			yyval.code	=	yyvsp[-1].expression;
		;}
    break;

  case 96:
#line 1044 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 97:
#line 1049 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 98:
#line 1054 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 99:
#line 1059 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 100:
#line 1064 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 101:
#line 1069 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 102:
#line 1074 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 103:
#line 1079 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 104:
#line 1084 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 105:
#line 1089 "sl.y"
    {
			yyval.code	=	yyvsp[-1].expression;
		;}
    break;

  case 106:
#line 1094 "sl.y"
    {
			yyval.code					=	new CNullExpression;
		;}
    break;

  case 107:
#line 1103 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 108:
#line 1108 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 109:
#line 1113 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 110:
#line 1118 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 111:
#line 1123 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 112:
#line 1128 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 113:
#line 1133 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 114:
#line 1142 "sl.y"
    {
			CFunction	*cFunction;
			int			bc;
			char		tmp[256];

			if (sscanf(yyvsp[-1].string,"%d",&bc) != 1) sdr->error("Invalid break count: %s\n",yyvsp[-1].string);

			if (bc <= 0) sdr->error("Bad break count: %s\n",yyvsp[-1].string);

			for(cFunction = sdr->functionStack->last(); cFunction != NULL; cFunction = sdr->functionStack->prev()) {
				if (strcmp(cFunction->symbolName,constantLoopName) == 0) bc--;
				else if (strcmp(cFunction->symbolName,constantBlockName) == 0) continue;

				if (bc == 0) break;

				sdr->error("Break target not found\n");
				break;
			}

			if (cFunction == NULL) sdr->error("Break target not found\n");

			sprintf(tmp,"%s\t%s\n",opcodeBreak,yyvsp[-1].string);

			yyval.code	=	new CFixedExpression(tmp);
		;}
    break;

  case 115:
#line 1169 "sl.y"
    {
			CFunction	*cFunction;
			char		tmp[256];
			int			bc	=	(int) 1;

			sdr->functionStack->push(sdr->lastFunction);
			for(cFunction = sdr->functionStack->last(); cFunction != NULL; cFunction = sdr->functionStack->prev()) {
				if (strcmp(cFunction->symbolName,constantLoopName) == 0) bc--;
				else if (strcmp(cFunction->symbolName,constantBlockName) == 0) continue;

				if (bc == 0) break;

				sdr->error("Break target not found\n");
				break;
			}
			sdr->lastFunction	=	sdr->functionStack->pop();

			if (cFunction == NULL) sdr->error("Break target not found\n");

			sprintf(tmp,"%s\t1\n",opcodeBreak);

			yyval.code	=	new CFixedExpression(tmp);
		;}
    break;

  case 116:
#line 1198 "sl.y"
    {
			CFunction	*cFunction;
			char		tmp[256];
			int			bc;

			if (sscanf(yyvsp[-1].string,"%d",&bc) != 1) sdr->error("Bad continue count: %s\n",yyvsp[-1].string);

			if (bc <= 0) sdr->error("Bad continue count: %s\n",yyvsp[-1].string);

			for(cFunction = sdr->functionStack->last(); cFunction != NULL; cFunction = sdr->functionStack->prev()) {
				if (strcmp(cFunction->symbolName,constantLoopName) == 0) bc--;
				else if (strcmp(cFunction->symbolName,constantBlockName) == 0) continue;

				if (bc == 0) break;

				sdr->error("Continue target not found\n");
				break;
			}

			if (cFunction == NULL) sdr->error("Continue target not found\n");

			sprintf(tmp,"%s\t%s\n",opcodeContinue,yyvsp[-1].string);

			yyval.code	=	new CFixedExpression(tmp);
		;}
    break;

  case 117:
#line 1225 "sl.y"
    {
			CFunction	*cFunction;
			char		tmp[256];
			int			bc	=	(int) 1;

			for(cFunction = sdr->functionStack->last(); cFunction != NULL; cFunction = sdr->functionStack->prev()) {
				if (strcmp(cFunction->symbolName,constantLoopName) == 0) bc--;
				else if (strcmp(cFunction->symbolName,constantBlockName) == 0) continue;

				if (bc == 0) break;
				
				sdr->error("Continue target not found\n");
				break;
			}

			if (cFunction == NULL) sdr->error("Continue target not found\n");

			sprintf(tmp,"%s\t1\n",opcodeContinue);

			yyval.code	=	new CFixedExpression(tmp);
		;}
    break;

  case 118:
#line 1252 "sl.y"
    {
			CFunction	*cFun	=	sdr->lastFunction;
			CExpression	*c;

			// Skip over loops
			for (cFun = sdr->functionStack->last(); cFun != NULL; cFun = sdr->functionStack->prev()) {
				if (strcmp(cFun->symbolName,constantBlockName) == 0) continue;
				if (strcmp(cFun->symbolName,constantLoopName) == 0) continue;
				break;
			}

			if (cFun ==	NULL) {
				sdr->error("Return target not found\n");
				yyval.code	=	new CNullExpression;
			} else {
				if (cFun->returnValue == NULL) {
					sdr->error("Function %s was not expecting a return value\n",cFun->symbolName);
					c	=	new CNullExpression;
				} else {
					c	=	new CAssignmentExpression(cFun->returnValue,yyvsp[-1].expression);				
				}

				yyval.code	=	c;

				cFun->returnValueGiven	=	TRUE;
			}
		;}
    break;

  case 119:
#line 1281 "sl.y"
    {
			CFunction	*cFun	=	sdr->lastFunction;

			// Skip over loops
			for (cFun = sdr->functionStack->last(); cFun != NULL; cFun = sdr->functionStack->prev()) {
				if (strcmp(cFun->symbolName,constantBlockName) == 0) continue;
				if (strcmp(cFun->symbolName,constantLoopName) == 0) continue;
				break;
			}

			if (cFun ==	NULL)	sdr->error("Return target not found\n");
			else {
				if (cFun->returnValue != NULL) {
					sdr->error("Function %s was expecting a return value\n",cFun->symbolName);
				}
			}
		;}
    break;

  case 120:
#line 1308 "sl.y"
    {
			CFunction	*cFun	=	sdr->newFunction(constantLoopName);
			
			yyval.expression	=	yyvsp[-1].expression;	
		;}
    break;

  case 121:
#line 1319 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CForLoop(NULL,yyvsp[-1].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 122:
#line 1329 "sl.y"
    {

			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CForLoop(NULL,yyvsp[-1].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 123:
#line 1342 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 124:
#line 1349 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {	
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CAssignmentExpression(cVar,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 125:
#line 1365 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 126:
#line 1372 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-6].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CArrayAssignmentExpression(cVar,yyvsp[-4].expression,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 127:
#line 1389 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 128:
#line 1396 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeAddFloatFloat,opcodeAddVectorVector,FALSE,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 129:
#line 1409 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 130:
#line 1416 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeSubFloatFloat,opcodeSubVectorVector,FALSE,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 131:
#line 1429 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeAddFloatFloat,opcodeAddVectorVector,FALSE,new CConstantTerminalExpression(SLC_FLOAT,strdup("1")));
			}
		;}
    break;

  case 132:
#line 1440 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeAddFloatFloat,opcodeAddVectorVector,FALSE,new CConstantTerminalExpression(SLC_FLOAT,strdup("-1")));
			}
		;}
    break;

  case 133:
#line 1451 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 134:
#line 1458 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeMulFloatFloat,opcodeMulVectorVector,FALSE,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 135:
#line 1471 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-1].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-1].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 136:
#line 1478 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CUpdateExpression(cVar,opcodeDivFloatFloat,opcodeDivVectorVector,FALSE,yyvsp[0].expression);
				sdr->undesire();
			}
		;}
    break;

  case 137:
#line 1494 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 138:
#line 1501 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-6].string);
			
			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-4].expression,yyvsp[0].expression,opcodeAddFloatFloat,opcodeAddVectorVector,opcodeAddMatrixMatrix);
				sdr->undesire();
			}
		;}
    break;

  case 139:
#line 1517 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 140:
#line 1524 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-6].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-4].expression,yyvsp[0].expression,opcodeSubFloatFloat,opcodeSubVectorVector,opcodeSubMatrixMatrix);
				sdr->undesire();
			}
		;}
    break;

  case 141:
#line 1540 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-2].expression,new CConstantTerminalExpression(SLC_FLOAT,strdup("1")),opcodeAddFloatFloat,opcodeAddVectorVector,opcodeAddMatrixMatrix);
			}
		;}
    break;

  case 142:
#line 1554 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-2].expression,new CConstantTerminalExpression(SLC_FLOAT,strdup("-1")),opcodeAddFloatFloat,opcodeAddVectorVector,opcodeAddMatrixMatrix);
			}
		;}
    break;

  case 143:
#line 1568 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 144:
#line 1575 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-6].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-4].expression,yyvsp[0].expression,opcodeMulFloatFloat,opcodeMulVectorVector,opcodeMulMatrixMatrix);
				sdr->undesire();
			}
		;}
    break;

  case 145:
#line 1591 "sl.y"
    {
			CVariable	*cVar				=	sdr->getVariable(yyvsp[-4].string);

			if (cVar == NULL)	sdr->error("Identifier %s not found\n",yyvsp[-4].string);
			else				sdr->desire(cVar->type);
		;}
    break;

  case 146:
#line 1598 "sl.y"
    {
			CVariable			*cVar		=	sdr->getVariable(yyvsp[-6].string);

			if (cVar == NULL) {
				yyval.expression	=	new CNullExpression;
			} else {
				yyval.expression	=	new CArrayUpdateExpression(cVar,yyvsp[-4].expression,yyvsp[0].expression,opcodeDivFloatFloat,opcodeDivVectorVector,opcodeDivMatrixMatrix);
				sdr->undesire();
			}
		;}
    break;

  case 147:
#line 1614 "sl.y"
    {
			CFunction	*cFun	=	sdr->newFunction(constantLoopName);
		;}
    break;

  case 148:
#line 1628 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CForLoop(yyvsp[-6].code,yyvsp[-4].expression,yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 149:
#line 1645 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CForLoop(yyvsp[-6].code,yyvsp[-4].expression,yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 150:
#line 1656 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 151:
#line 1660 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 152:
#line 1671 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 153:
#line 1676 "sl.y"
    {
			yyval.code	=	yyvsp[0].expression;
		;}
    break;

  case 154:
#line 1685 "sl.y"
    {
			yyval.expression	=	getConversion(SLC_BOOLEAN,yyvsp[0].expression);
		;}
    break;

  case 155:
#line 1689 "sl.y"
    {
			yyval.expression	=	new CConstantTerminalExpression(SLC_BOOLEAN | SLC_UNIFORM,strdup("true"));
		;}
    break;

  case 156:
#line 1698 "sl.y"
    {
			yyval.code	=	yyvsp[0].code;
		;}
    break;

  case 157:
#line 1702 "sl.y"
    {
			yyval.code	=	new CNullExpression;
		;}
    break;

  case 158:
#line 1713 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 159:
#line 1718 "sl.y"
    {
			yyval.code	=	yyvsp[0].expression;
		;}
    break;

  case 160:
#line 1725 "sl.y"
    {
			yyval.code	=	new CTwoExpressions(yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 161:
#line 1730 "sl.y"
    {
			yyval.code	=	yyvsp[0].expression;
		;}
    break;

  case 162:
#line 1745 "sl.y"
    {
			yyval.code	=	new CIfThenElse(yyvsp[-4].expression,yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 163:
#line 1758 "sl.y"
    {
			yyval.code	=	new CIfThenElse(yyvsp[-2].expression,yyvsp[0].code,NULL);
		;}
    break;

  case 164:
#line 1769 "sl.y"
    {
			yyval.code	=	new CIfThenElse(yyvsp[-4].expression,yyvsp[-2].code,yyvsp[0].code);
		;}
    break;

  case 165:
#line 1782 "sl.y"
    {
			yyval.array->push(yyvsp[0].expression);
		;}
    break;

  case 166:
#line 1787 "sl.y"
    {
			sdr->actualParameters->push(yyvsp[0].expression);
			yyval.array	=	sdr->actualParameters;
		;}
    break;

  case 167:
#line 1796 "sl.y"
    {
			sdr->actualParameterStack->push(sdr->actualParameters);
			sdr->actualParameters	=	new CArray<CExpression *>;
		;}
    break;

  case 168:
#line 1802 "sl.y"
    {
			yyval.array	=	yyvsp[-1].array;
		;}
    break;

  case 169:
#line 1814 "sl.y"
    {
			yyval.code	=	new CGatherThenElse(yyvsp[-3].array,yyvsp[-2].code,yyvsp[0].code);
			sdr->actualParameters	=	sdr->actualParameterStack->pop();
		;}
    break;

  case 170:
#line 1825 "sl.y"
    {
			yyval.code	=	new CGatherThenElse(yyvsp[-1].array,yyvsp[0].code,NULL);
			sdr->actualParameters	=	sdr->actualParameterStack->pop();
		;}
    break;

  case 171:
#line 1834 "sl.y"
    {
			yyval.code	=	new CGatherThenElse(yyvsp[-3].array,yyvsp[-2].code,yyvsp[0].code);
			sdr->actualParameters	=	sdr->actualParameterStack->pop();
		;}
    break;

  case 172:
#line 1844 "sl.y"
    {
			CFunction	*cCFunction	=	sdr->newFunction(constantLoopName);

			sdr->requiredShaderContext	|=	SLC_SURFACE;
		;}
    break;

  case 173:
#line 1856 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(NULL,yyvsp[-2].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 174:
#line 1869 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(NULL,yyvsp[-2].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 175:
#line 1884 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(yyvsp[-6].expression,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 176:
#line 1901 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(yyvsp[-6].expression,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 177:
#line 1914 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(yyvsp[-2].expression,NULL,NULL,yyvsp[0].code);
		;}
    break;

  case 178:
#line 1929 "sl.y"
    {
			CFunction	*cFun	=	sdr->popFunction();

			yyval.code	=	new CIlluminationLoop(yyvsp[-6].expression,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 179:
#line 1944 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeIlluminate,opcodeEndIlluminate,yyvsp[-2].expression,NULL,NULL,yyvsp[0].code);
		;}
    break;

  case 180:
#line 1959 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeIlluminate,opcodeEndIlluminate,yyvsp[-6].expression,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 181:
#line 1972 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeIlluminate,opcodeEndIlluminate,yyvsp[-2].expression,NULL,NULL,yyvsp[0].code);
		;}
    break;

  case 182:
#line 1987 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeIlluminate,opcodeEndIlluminate,yyvsp[-6].expression,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].code);
		;}
    break;

  case 183:
#line 2001 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeSolar,opcodeEndSolar,NULL,NULL,NULL,yyvsp[0].code);
		;}
    break;

  case 184:
#line 2014 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeSolar,opcodeEndSolar,yyvsp[-4].expression,yyvsp[-2].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 185:
#line 2026 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeSolar,opcodeEndSolar,NULL,NULL,NULL,yyvsp[0].code);
		;}
    break;

  case 186:
#line 2039 "sl.y"
    {
			sdr->requiredShaderContext	|=	SLC_LIGHT;

			yyval.code	=	new CIlluminateSolar(opcodeSolar,opcodeEndSolar,yyvsp[-4].expression,yyvsp[-2].expression,NULL,yyvsp[0].code);
		;}
    break;

  case 187:
#line 2050 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 188:
#line 2057 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeAddFloatFloat,opcodeAddVectorVector,opcodeAddMatrixMatrix,NULL,NULL);
		;}
    break;

  case 189:
#line 2064 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeSubFloatFloat,opcodeSubVectorVector,opcodeSubMatrixMatrix,NULL,NULL);
		;}
    break;

  case 190:
#line 2071 "sl.y"
    {
			yyval.expression	=	NULL;

			if (yyvsp[-2].expression->type & SLC_MATRIX) {
				if (yyvsp[0].expression->type & SLC_VVECTOR) {
					yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VVECTOR,opcodeMulMatrixVector,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
				} else if (yyvsp[0].expression->type & SLC_VPOINT) {
					yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VPOINT,opcodeMulMatrixPoint,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
				} else if (yyvsp[0].expression->type & SLC_VNORMAL) {
					yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VNORMAL,opcodeMulMatrixNormal,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
				}
			}

			if (yyval.expression == NULL) {
				if (yyvsp[0].expression->type & SLC_MATRIX) {
					if (yyvsp[-2].expression->type & SLC_VVECTOR) {
						yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VVECTOR,opcodeMulVectorMatrix,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
					} else if (yyvsp[-2].expression->type & SLC_VPOINT) {
						yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VPOINT,opcodeMulPointMatrix,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
					} else if (yyvsp[-2].expression->type & SLC_VNORMAL) {
						yyval.expression	=	new CBinaryExpression(SLC_VECTOR | SLC_VNORMAL,opcodeMulNormalMatrix,yyvsp[-2].expression,getConversion(SLC_VECTOR,yyvsp[0].expression));
					}
				}
			}


			if (yyval.expression == NULL)
				yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeMulFloatFloat,opcodeMulVectorVector,opcodeMulMatrixMatrix,NULL,NULL);
		;}
    break;

  case 191:
#line 2104 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeDivFloatFloat,opcodeDivVectorVector,opcodeDivMatrixMatrix,NULL,NULL);
		;}
    break;

  case 192:
#line 2110 "sl.y"
    {
			sdr->desire(SLC_VECTOR | SLC_VVECTOR);
		;}
    break;

  case 193:
#line 2114 "sl.y"
    {
			sdr->undesire();
			yyval.expression	=	new CBinaryExpression(SLC_FLOAT,opcodeDotProduct,getConversion(SLC_VECTOR,yyvsp[-3].expression),getConversion(SLC_VECTOR,yyvsp[0].expression));
		;}
    break;

  case 194:
#line 2122 "sl.y"
    {
			yyval.expression	=	new CBinaryExpression(SLC_VECTOR,opcodeCrossProduct,getConversion(SLC_VECTOR,yyvsp[-2].expression),getConversion(SLC_VECTOR,yyvsp[0].expression));
		;}
    break;

  case 195:
#line 2128 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;	
		;}
    break;

  case 196:
#line 2134 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[0].expression,opcodeNegFloat,opcodeNegVector,opcodeNegMatrix,NULL,NULL);
		;}
    break;

  case 197:
#line 2143 "sl.y"
    {
			int	ft	=	yyvsp[-2].expression->type;
			int	st	=	yyvsp[0].expression->type;

			if ((yyvsp[-2].expression->type & SLC_TYPE_MASK) == (yyvsp[0].expression->type & SLC_TYPE_MASK)) {
				yyval.expression	=	new CConditionalExpression(yyvsp[-2].expression->type,yyvsp[-4].expression,yyvsp[-2].expression,yyvsp[0].expression);
			} else {
				sdr->error("Type mismatch in conditional execution\n");
			}
		;}
    break;

  case 198:
#line 2159 "sl.y"
    {
			yyval.array	=	yyvsp[-1].array;
		;}
    break;

  case 199:
#line 2168 "sl.y"
    {
			yyval.array	=	yyvsp[0].array;
			yyval.array->push(yyvsp[-2].expression);
		;}
    break;

  case 200:
#line 2174 "sl.y"
    {
			yyval.array	=	new CArray<CExpression *>;
			yyval.array->push(yyvsp[0].expression);
		;}
    break;

  case 201:
#line 2182 "sl.y"
    {
			yyval.expression	=	new CConstantTerminalExpression(SLC_FLOAT | SLC_UNIFORM,strdup("3.141592654"));
		;}
    break;

  case 202:
#line 2187 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 203:
#line 2192 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 204:
#line 2197 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 205:
#line 2202 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 206:
#line 2207 "sl.y"
    {
	
			CVariable	*cVar	=	sdr->getVariable(yyvsp[0].string);

			if (cVar == NULL) {
				sdr->error("Identifier %s not found\n",yyvsp[0].string);
				yyval.expression	=	new CNullExpression;
			} else { 
				yyval.expression	=	new CTerminalExpression(cVar);
			}
		;}
    break;

  case 207:
#line 2223 "sl.y"
    {
			CVariable *cVar	=	sdr->getVariable(yyvsp[-3].string);

			if (cVar == NULL) {
				sdr->error("Identifier %s not found\n",yyvsp[-3].string);
				yyval.expression	=	new CNullExpression;
			} else { 
				yyval.expression	=	new CArrayExpression(cVar,yyvsp[-1].expression);
			}
		;}
    break;

  case 208:
#line 2235 "sl.y"
    {
			yyval.expression	=	new CConstantTerminalExpression(SLC_FLOAT,strdup(yyvsp[0].string));
		;}
    break;

  case 209:
#line 2240 "sl.y"
    {
			yyval.expression	=	new CConstantTerminalExpression(SLC_STRING,strdup(yyvsp[0].string));
		;}
    break;

  case 210:
#line 2251 "sl.y"
    {
			yyval.expression	=	new CVectorExpression(yyvsp[-5].expression,yyvsp[-3].expression,yyvsp[-1].expression);
		;}
    break;

  case 211:
#line 2288 "sl.y"
    {
			CExpression	*elements[16];

			elements[0]		=	yyvsp[-31].expression;
			elements[1]		=	yyvsp[-29].expression;
			elements[2]		=	yyvsp[-27].expression;
			elements[3]		=	yyvsp[-25].expression;
			elements[4]		=	yyvsp[-23].expression;
			elements[5]		=	yyvsp[-21].expression;
			elements[6]		=	yyvsp[-19].expression;
			elements[7]		=	yyvsp[-17].expression;
			elements[8]		=	yyvsp[-15].expression;
			elements[9]		=	yyvsp[-13].expression;
			elements[10]	=	yyvsp[-11].expression;
			elements[11]	=	yyvsp[-9].expression;
			elements[12]	=	yyvsp[-7].expression;
			elements[13]	=	yyvsp[-5].expression;
			elements[14]	=	yyvsp[-3].expression;
			elements[15]	=	yyvsp[-1].expression;

			yyval.expression				=	new CMatrixExpression(elements);
		;}
    break;

  case 212:
#line 2314 "sl.y"
    {	
			yyval.expression	=	yyvsp[-1].expression;
		;}
    break;

  case 213:
#line 2323 "sl.y"
    {
			yyval.expression	=	getConversion(yyvsp[-1].integer,yyvsp[0].expression);

			sdr->undesire();
		;}
    break;

  case 214:
#line 2332 "sl.y"
    {
			yyval.expression	=	getConversion(yyvsp[-2].integer,yyvsp[-1].string,yyvsp[0].expression);

			sdr->undesire();
		;}
    break;

  case 215:
#line 2343 "sl.y"
    {
			yyval.expression	=	yyvsp[-1].expression;
		;}
    break;

  case 216:
#line 2350 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,NULL,NULL,NULL,NULL,opcodeAnd);
		;}
    break;

  case 217:
#line 2357 "sl.y"
    {
			yyval.expression	=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,NULL,NULL,NULL,NULL,opcodeOr);
		;}
    break;

  case 218:
#line 2364 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatGreater,opcodeVectorGreater,NULL,NULL,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 219:
#line 2372 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatLess,opcodeVectorLess,NULL,NULL,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 220:
#line 2380 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatEGreater,opcodeVectorEGreater,NULL,NULL,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 221:
#line 2388 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatELess,opcodeVectorELess,NULL,NULL,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 222:
#line 2396 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatEqual,opcodeVectorEqual,NULL,opcodeStringEqual,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 223:
#line 2404 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,opcodeFloatNotEqual,opcodeVectorNotEqual,NULL,opcodeStringNotEqual,NULL);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 224:
#line 2412 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,NULL,NULL,NULL,NULL,opcodeAnd);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 225:
#line 2420 "sl.y"
    {
			yyval.expression			=	getOperation(yyvsp[-2].expression,yyvsp[0].expression,NULL,NULL,NULL,NULL,opcodeXor);
			yyval.expression->type	=	SLC_BOOLEAN | (yyvsp[-2].expression->type & yyvsp[0].expression->type & SLC_UNIFORM);
		;}
    break;

  case 226:
#line 2427 "sl.y"
    {
			yyval.expression			=	new CUnaryExpression(SLC_BOOLEAN,opcodeNot,getConversion(SLC_BOOLEAN,yyvsp[0].expression));
		;}
    break;

  case 227:
#line 2437 "sl.y"
    {
			CFunctionPrototype		*cFun;
			CArray<CExpression *>	*parameters	=	sdr->actualParameters;	// This is the list of parameters to the function

			char					*funName	=	yyvsp[0].string;

			// Clear the desired type flags
			sdr->undesire();

			// Restore the old parameters
			sdr->actualParameters		=	sdr->actualParameterStack->pop();


			// Check the builtin functions
			for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
				if (cFun->perfectMatch(yyvsp[0].string,parameters,sdr->desired())) break;
			}

			if (cFun == NULL) {
				for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
					if (cFun->match(yyvsp[0].string,parameters,sdr->desired())) break;
				}
			}

			if (cFun != NULL) {
				yyval.expression	=	new CBuiltinExpression(cFun,parameters);
			} else {
				sdr->error("Function %s not found\n",yyvsp[0].string);
				if (parameters->numItems != 0) {
					CExpression	*cCode;
					while((cCode = parameters->pop()) != NULL) {
						delete cCode;
					}
				}
				delete parameters;
				yyval.expression	=	new CNullExpression;
			}
		;}
    break;

  case 228:
#line 2477 "sl.y"
    {
			yyval.expression	=	yyvsp[0].expression;
		;}
    break;

  case 229:
#line 2487 "sl.y"
    {
			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);

			// Set the name
			yyval.string	=	yyvsp[-1].string;
		;}
    break;

  case 230:
#line 2502 "sl.y"
    {
			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);

			// Set the name
			yyval.string	=	"surface";
		;}
    break;

  case 231:
#line 2517 "sl.y"
    {
			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);

			// Set the name
			yyval.string	=	"displacement";
		;}
    break;

  case 232:
#line 2535 "sl.y"
    {
			CFunction				*cFun;
			CArray<CExpression *>	*parameters	=	sdr->actualParameters;	// This is the list of parameters to the function

			char					*funName	=	yyvsp[-2].string;

			// Clear the desired type flags
			sdr->undesire();

			// Restore the old parameters
			sdr->actualParameters		=	sdr->actualParameterStack->pop();

			// Search for the CFunction here....
			cFun	=	sdr->getFunction(yyvsp[-2].string,parameters);

			if (cFun != NULL) {													// Cool, the function exists
				// A function with the same name is defined ... 
				// Try to match the parameters;
				if (cFun->parameters->numItems == parameters->numItems) {	// The number of parameters match
					// A function with the same name is defined and the number of Parameters match
					yyval.expression	=	new CFuncallExpression(cFun,parameters);					
				}
			}

			// If not found, check the predefined CFunctions
			if (cFun == NULL) {
				CFunctionPrototype	*cFun;
				char				*fName	=	yyvsp[-2].string;
				// Check the builtin CFunctions

				for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
					if (cFun->perfectMatch(yyvsp[-2].string,parameters,sdr->desired())) break;
				}

				if (cFun == NULL) {
					for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
						if (cFun->match(yyvsp[-2].string,parameters,sdr->desired())) break;
					}
				}

				// Check if there is a DSO implementing this function
				if (cFun == NULL) {
					sdr->enumerateDso(yyvsp[-2].string);

					for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
						if (cFun->perfectMatch(yyvsp[-2].string,parameters,sdr->desired())) break;
					}

					if (cFun == NULL) {
						for (cFun = sdr->builtinFunctions->first(); cFun != NULL; cFun = sdr->builtinFunctions->next()) {
							if (cFun->match(yyvsp[-2].string,parameters,sdr->desired())) break;
						}
					}
				}

				if (cFun != NULL) {
					yyval.expression	=	new CBuiltinExpression(cFun,parameters);
				} else {
					sdr->error("Function %s not found\n",yyvsp[-2].string);
					if (parameters->numItems != 0) {
						CExpression	*cCode;
						while((cCode = parameters->pop()) != NULL) {
							delete cCode;
						}
					}
					delete parameters;
					yyval.expression	=	new CNullExpression;
				}

			}
		;}
    break;

  case 233:
#line 2612 "sl.y"
    {
			yyval.code	=	new CConstantTerminalExpression(SLC_STRING | SLC_UNIFORM,strdup(yyvsp[0].string));
		;}
    break;

  case 234:
#line 2617 "sl.y"
    {
			CVariable	*cVar	=	sdr->getVariable(yyvsp[0].string);

			if (cVar != NULL)	yyval.code	=	new CTerminalExpression(cVar);
			else				yyval.code	=	new CNullExpression;
		;}
    break;

  case 235:
#line 2630 "sl.y"
    {
			yyval.code	=	getConversion(SLC_FLOAT | (yyvsp[-1].expression->type & SLC_UNIFORM),yyvsp[-1].expression);
		;}
    break;

  case 236:
#line 2634 "sl.y"
    {
			yyval.code	=	new CConstantTerminalExpression(SLC_FLOAT | SLC_UNIFORM,strdup("0"));
		;}
    break;

  case 237:
#line 2652 "sl.y"
    {
			// Fake the parameters
			CArray<CExpression *>	*parameters	=	sdr->actualParameters;	// This is the list of parameters to the function
			CArray<CExpression *>	*pl			=	new CArray<CExpression *>;
			CExpression				*cExpression;

			pl->push(yyvsp[-4].code);
			pl->push(yyvsp[-3].code);
			for (cExpression=parameters->first();cExpression!=NULL;cExpression=parameters->next())
				pl->push(cExpression);

			delete parameters;
			sdr->actualParameters	=	pl;

			yyval.string						=	yyvsp[-6].string;
		;}
    break;

  case 238:
#line 2674 "sl.y"
    {
			// Fake the parameters
			CArray<CExpression *>	*parameters	=	sdr->actualParameters;	// This is the list of parameters to the function
			CArray<CExpression *>	*pl			=	new CArray<CExpression *>;
			CExpression				*cExpression;

			pl->push(yyvsp[-2].code);
			pl->push(yyvsp[-1].code);
			for (cExpression=parameters->first();cExpression!=NULL;cExpression=parameters->next())
				pl->push(cExpression);

			delete parameters;
			sdr->actualParameters	=	pl;

			yyval.string						=	yyvsp[-4].string;
		;}
    break;

  case 239:
#line 2694 "sl.y"
    {
			yyval.string	=	"texture";

			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);
		;}
    break;

  case 240:
#line 2707 "sl.y"
    {
			yyval.string	=	"shadow";

			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);
		;}
    break;

  case 241:
#line 2720 "sl.y"
    {
			yyval.string	=	"environment";

			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);
		;}
    break;

  case 242:
#line 2733 "sl.y"
    {
			yyval.string	=	"bump";

			// Save the old parameters
			sdr->actualParameterStack->push(sdr->actualParameters);
			// Start a new parameter list
			sdr->actualParameters	=	new CArray<CExpression *>;

			// Make sure we do not do something stupid with the parameters
			sdr->desire(SLC_NONE);
		;}
    break;

  case 243:
#line 2750 "sl.y"
    {
		;}
    break;

  case 244:
#line 2753 "sl.y"
    {
		;}
    break;

  case 245:
#line 2760 "sl.y"
    {
			sdr->actualParameters->push(yyvsp[-1].expression);
		;}
    break;

  case 246:
#line 2764 "sl.y"
    {
		;}
    break;

  case 247:
#line 2768 "sl.y"
    {
			sdr->actualParameters->push(yyvsp[0].expression);
		;}
    break;


    }

/* Line 1010 of yacc.c.  */
#line 4418 "sl.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 2773 "sl.y"



#include	"lex.sl.cpp"



int	CScriptContext::compile(FILE *in,char *outName) {
	
	sdr	=	this;

	yyin	=	in;

	yyparse();

	if (compileError == 0) {
		char		*tmp;

		if (outName == NULL) {
			// If there's no compile error, dump the compiled code
			tmp	=	new char[strlen(sdr->shaderName)+5];

			strcpy(tmp,sdr->shaderName);
			strcat(tmp,".sdr");
		} else {
			tmp	=	outName;
		}

		sdr->generateCode(tmp);

		if (tmp != outName) delete [] tmp;

		return TRUE;
	}
	return FALSE;
}


void	yyerror(char *mes) {
	sdr->error("Parse error\n");
}





